/* -*-C-*-

$Id: ntapi.h,v 1.11 1999/04/07 04:01:43 cph Exp $

Copyright (c) 1997, 1999 Massachusetts Institute of Technology

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* This flag, defined by "syscall.h", means to define the syscall
   enums normally defined by that file.  */
#ifdef DEFINE_WIN32_SYSCALLS

enum syscall_names
{
  /* Native Win32 API procedures: */
  apicall_CloseHandle,
  apicall_CopyFile,
  apicall_CreateDirectory,
  apicall_CreateFile,
  apicall_CreatePipe,
  apicall_CreateProcess,
  apicall_DeleteFile,
  apicall_DuplicateHandle,
  apicall_EnumWindows,
  apicall_ExpandEnvironmentStrings,
  apicall_FindFirstFile,
  apicall_GetExitCodeProcess,
  apicall_GetFileAttributes,
  apicall_GetFileInformationByHandle,
  apicall_GetFileSize,
  apicall_GetFileTime,
  apicall_GetKeyboardState,
  apicall_GetStdHandle,
  apicall_InitializeSecurityDescriptor,
  apicall_MoveFile,
  apicall_MsgWaitForMultipleObjects,
  apicall_PeekNamedPipe,
  apicall_ReadFile,
  apicall_RegCloseKey,
  apicall_RegCreateKeyEx,
  apicall_RegDeleteKey,
  apicall_RegDeleteValue,
  apicall_RegEnumKeyEx,
  apicall_RegEnumValue,
  apicall_RegOpenKeyEx,
  apicall_RegQueryInfoKey,
  apicall_RegQueryValueEx,
  apicall_RegSetValueEx,
  apicall_RemoveDirectory,
  apicall_SetCurrentDirectory,
  apicall_SetFileAttributes,
  apicall_SetFilePointer,
  apicall_SetFileTime,
  apicall_SetKeyboardState,
  apicall_SetSecurityDescriptorDacl,
  apicall_SetStdHandle,
  apicall_SetTimer,
  apicall_TerminateProcess,
  apicall_WaitForMultipleObjects,
  apicall_WaitForSingleObject,
  apicall_WriteFile,

  /* Winsock procedures: */
  apicall_accept,
  apicall_bind,
  apicall_closesocket,
  apicall_connect,
  apicall_gethostbyname,
  apicall_gethostname,
  apicall_ioctlsocket,
  apicall_listen,
  apicall_recv,
  apicall_send,
  apicall_socket,

  /* C Library's unix-style procedures: */
  syscall_close,
  syscall_fstat,
  syscall_getcwd,
  syscall_gmtime,
  syscall_localtime,
  syscall_lseek,
  syscall_malloc,
  syscall_mkdir,
  syscall_mktime,
  syscall_open,
  syscall_read,
  syscall_realloc,
  syscall_rmdir,
  syscall_stat,
  syscall_unlink,
  syscall_write
};

/* Machine-generated table, do not edit: */
enum syserr_names
{
  /* Win32 error codes: */
  syserr_success,
  syserr_invalid_function,
  syserr_file_not_found,
  syserr_path_not_found,
  syserr_too_many_open_files,
  syserr_access_denied,
  syserr_invalid_handle,
  syserr_arena_trashed,
  syserr_not_enough_memory,
  syserr_invalid_block,
  syserr_bad_environment,
  syserr_bad_format,
  syserr_invalid_access,
  syserr_invalid_data,
  syserr_outofmemory,
  syserr_invalid_drive,
  syserr_current_directory,
  syserr_not_same_device,
  syserr_no_more_files,
  syserr_write_protect,
  syserr_bad_unit,
  syserr_not_ready,
  syserr_bad_command,
  syserr_crc,
  syserr_bad_length,
  syserr_seek,
  syserr_not_dos_disk,
  syserr_sector_not_found,
  syserr_out_of_paper,
  syserr_write_fault,
  syserr_read_fault,
  syserr_gen_failure,
  syserr_sharing_violation,
  syserr_lock_violation,
  syserr_wrong_disk,
  syserr_sharing_buffer_exceeded,
  syserr_handle_eof,
  syserr_handle_disk_full,
  syserr_not_supported,
  syserr_rem_not_list,
  syserr_dup_name,
  syserr_bad_netpath,
  syserr_network_busy,
  syserr_dev_not_exist,
  syserr_too_many_cmds,
  syserr_adap_hdw_err,
  syserr_bad_net_resp,
  syserr_unexp_net_err,
  syserr_bad_rem_adap,
  syserr_printq_full,
  syserr_no_spool_space,
  syserr_print_cancelled,
  syserr_netname_deleted,
  syserr_network_access_denied,
  syserr_bad_dev_type,
  syserr_bad_net_name,
  syserr_too_many_names,
  syserr_too_many_sess,
  syserr_sharing_paused,
  syserr_req_not_accep,
  syserr_redir_paused,
  syserr_file_exists,
  syserr_cannot_make,
  syserr_fail_i24,
  syserr_out_of_structures,
  syserr_already_assigned,
  syserr_invalid_password,
  syserr_invalid_parameter,
  syserr_net_write_fault,
  syserr_no_proc_slots,
  syserr_too_many_semaphores,
  syserr_excl_sem_already_owned,
  syserr_sem_is_set,
  syserr_too_many_sem_requests,
  syserr_invalid_at_interrupt_time,
  syserr_sem_owner_died,
  syserr_sem_user_limit,
  syserr_disk_change,
  syserr_drive_locked,
  syserr_broken_pipe,
  syserr_open_failed,
  syserr_buffer_overflow,
  syserr_disk_full,
  syserr_no_more_search_handles,
  syserr_invalid_target_handle,
  syserr_invalid_category,
  syserr_invalid_verify_switch,
  syserr_bad_driver_level,
  syserr_call_not_implemented,
  syserr_sem_timeout,
  syserr_insufficient_buffer,
  syserr_invalid_name,
  syserr_invalid_level,
  syserr_no_volume_label,
  syserr_mod_not_found,
  syserr_proc_not_found,
  syserr_wait_no_children,
  syserr_child_not_complete,
  syserr_direct_access_handle,
  syserr_negative_seek,
  syserr_seek_on_device,
  syserr_is_join_target,
  syserr_is_joined,
  syserr_is_substed,
  syserr_not_joined,
  syserr_not_substed,
  syserr_join_to_join,
  syserr_subst_to_subst,
  syserr_join_to_subst,
  syserr_subst_to_join,
  syserr_busy_drive,
  syserr_same_drive,
  syserr_dir_not_root,
  syserr_dir_not_empty,
  syserr_is_subst_path,
  syserr_is_join_path,
  syserr_path_busy,
  syserr_is_subst_target,
  syserr_system_trace,
  syserr_invalid_event_count,
  syserr_too_many_muxwaiters,
  syserr_invalid_list_format,
  syserr_label_too_long,
  syserr_too_many_tcbs,
  syserr_signal_refused,
  syserr_discarded,
  syserr_not_locked,
  syserr_bad_threadid_addr,
  syserr_bad_arguments,
  syserr_bad_pathname,
  syserr_signal_pending,
  syserr_max_thrds_reached,
  syserr_lock_failed,
  syserr_busy,
  syserr_cancel_violation,
  syserr_atomic_locks_not_supported,
  syserr_invalid_segment_number,
  syserr_invalid_ordinal,
  syserr_already_exists,
  syserr_invalid_flag_number,
  syserr_sem_not_found,
  syserr_invalid_starting_codeseg,
  syserr_invalid_stackseg,
  syserr_invalid_moduletype,
  syserr_invalid_exe_signature,
  syserr_exe_marked_invalid,
  syserr_bad_exe_format,
  syserr_iterated_data_exceeds_64k,
  syserr_invalid_minallocsize,
  syserr_dynlink_from_invalid_ring,
  syserr_iopl_not_enabled,
  syserr_invalid_segdpl,
  syserr_autodataseg_exceeds_64k,
  syserr_ring2seg_must_be_movable,
  syserr_reloc_chain_xeeds_seglim,
  syserr_infloop_in_reloc_chain,
  syserr_envvar_not_found,
  syserr_no_signal_sent,
  syserr_filename_exced_range,
  syserr_ring2_stack_in_use,
  syserr_meta_expansion_too_long,
  syserr_invalid_signal_number,
  syserr_thread_1_inactive,
  syserr_locked,
  syserr_too_many_modules,
  syserr_nesting_not_allowed,
  syserr_bad_pipe,
  syserr_pipe_busy,
  syserr_no_data,
  syserr_pipe_not_connected,
  syserr_more_data,
  syserr_vc_disconnected,
  syserr_invalid_ea_name,
  syserr_ea_list_inconsistent,
  syserr_no_more_items,
  syserr_cannot_copy,
  syserr_directory,
  syserr_eas_didnt_fit,
  syserr_ea_file_corrupt,
  syserr_ea_table_full,
  syserr_invalid_ea_handle,
  syserr_eas_not_supported,
  syserr_not_owner,
  syserr_too_many_posts,
  syserr_partial_copy,
  syserr_mr_mid_not_found,
  syserr_invalid_address,
  syserr_arithmetic_overflow,
  syserr_pipe_connected,
  syserr_pipe_listening,
  syserr_ea_access_denied,
  syserr_operation_aborted,
  syserr_io_incomplete,
  syserr_io_pending,
  syserr_noaccess,
  syserr_swaperror,
  syserr_stack_overflow,
  syserr_invalid_message,
  syserr_can_not_complete,
  syserr_invalid_flags,
  syserr_unrecognized_volume,
  syserr_file_invalid,
  syserr_fullscreen_mode,
  syserr_no_token,
  syserr_baddb,
  syserr_badkey,
  syserr_cantopen,
  syserr_cantread,
  syserr_cantwrite,
  syserr_registry_recovered,
  syserr_registry_corrupt,
  syserr_registry_io_failed,
  syserr_not_registry_file,
  syserr_key_deleted,
  syserr_no_log_space,
  syserr_key_has_children,
  syserr_child_must_be_volatile,
  syserr_notify_enum_dir,
  syserr_dependent_services_running,
  syserr_invalid_service_control,
  syserr_service_request_timeout,
  syserr_service_no_thread,
  syserr_service_database_locked,
  syserr_service_already_running,
  syserr_invalid_service_account,
  syserr_service_disabled,
  syserr_circular_dependency,
  syserr_service_does_not_exist,
  syserr_service_cannot_accept_ctrl,
  syserr_service_not_active,
  syserr_failed_service_controller_connect,
  syserr_exception_in_service,
  syserr_database_does_not_exist,
  syserr_service_specific_error,
  syserr_process_aborted,
  syserr_service_dependency_fail,
  syserr_service_logon_failed,
  syserr_service_start_hang,
  syserr_invalid_service_lock,
  syserr_service_marked_for_delete,
  syserr_service_exists,
  syserr_already_running_lkg,
  syserr_service_dependency_deleted,
  syserr_boot_already_accepted,
  syserr_service_never_started,
  syserr_duplicate_service_name,
  syserr_end_of_media,
  syserr_filemark_detected,
  syserr_beginning_of_media,
  syserr_setmark_detected,
  syserr_no_data_detected,
  syserr_partition_failure,
  syserr_invalid_block_length,
  syserr_device_not_partitioned,
  syserr_unable_to_lock_media,
  syserr_unable_to_unload_media,
  syserr_media_changed,
  syserr_bus_reset,
  syserr_no_media_in_drive,
  syserr_no_unicode_translation,
  syserr_dll_init_failed,
  syserr_shutdown_in_progress,
  syserr_no_shutdown_in_progress,
  syserr_io_device,
  syserr_serial_no_device,
  syserr_irq_busy,
  syserr_more_writes,
  syserr_counter_timeout,
  syserr_floppy_id_mark_not_found,
  syserr_floppy_wrong_cylinder,
  syserr_floppy_unknown_error,
  syserr_floppy_bad_registers,
  syserr_disk_recalibrate_failed,
  syserr_disk_operation_failed,
  syserr_disk_reset_failed,
  syserr_eom_overflow,
  syserr_not_enough_server_memory,
  syserr_possible_deadlock,
  syserr_mapped_alignment,
  syserr_set_power_state_vetoed,
  syserr_set_power_state_failed,
  syserr_old_win_version,
  syserr_app_wrong_os,
  syserr_single_instance_app,
  syserr_rmode_app,
  syserr_invalid_dll,
  syserr_no_association,
  syserr_dde_fail,
  syserr_dll_not_found,
  syserr_bad_username,
  syserr_not_connected,
  syserr_open_files,
  syserr_active_connections,
  syserr_device_in_use,
  syserr_bad_device,
  syserr_connection_unavail,
  syserr_device_already_remembered,
  syserr_no_net_or_bad_path,
  syserr_bad_provider,
  syserr_cannot_open_profile,
  syserr_bad_profile,
  syserr_not_container,
  syserr_extended_error,
  syserr_invalid_groupname,
  syserr_invalid_computername,
  syserr_invalid_eventname,
  syserr_invalid_domainname,
  syserr_invalid_servicename,
  syserr_invalid_netname,
  syserr_invalid_sharename,
  syserr_invalid_passwordname,
  syserr_invalid_messagename,
  syserr_invalid_messagedest,
  syserr_session_credential_conflict,
  syserr_remote_session_limit_exceeded,
  syserr_dup_domainname,
  syserr_no_network,
  syserr_cancelled,
  syserr_user_mapped_file,
  syserr_connection_refused,
  syserr_graceful_disconnect,
  syserr_address_already_associated,
  syserr_address_not_associated,
  syserr_connection_invalid,
  syserr_connection_active,
  syserr_network_unreachable,
  syserr_host_unreachable,
  syserr_protocol_unreachable,
  syserr_port_unreachable,
  syserr_request_aborted,
  syserr_connection_aborted,
  syserr_retry,
  syserr_connection_count_limit,
  syserr_login_time_restriction,
  syserr_login_wksta_restriction,
  syserr_incorrect_address,
  syserr_already_registered,
  syserr_service_not_found,
  syserr_not_authenticated,
  syserr_not_logged_on,
  syserr_continue,
  syserr_already_initialized,
  syserr_no_more_devices,
  syserr_not_all_assigned,
  syserr_some_not_mapped,
  syserr_no_quotas_for_account,
  syserr_local_user_session_key,
  syserr_null_lm_password,
  syserr_unknown_revision,
  syserr_revision_mismatch,
  syserr_invalid_owner,
  syserr_invalid_primary_group,
  syserr_no_impersonation_token,
  syserr_cant_disable_mandatory,
  syserr_no_logon_servers,
  syserr_no_such_logon_session,
  syserr_no_such_privilege,
  syserr_privilege_not_held,
  syserr_invalid_account_name,
  syserr_user_exists,
  syserr_no_such_user,
  syserr_group_exists,
  syserr_no_such_group,
  syserr_member_in_group,
  syserr_member_not_in_group,
  syserr_last_admin,
  syserr_wrong_password,
  syserr_ill_formed_password,
  syserr_password_restriction,
  syserr_logon_failure,
  syserr_account_restriction,
  syserr_invalid_logon_hours,
  syserr_invalid_workstation,
  syserr_password_expired,
  syserr_account_disabled,
  syserr_none_mapped,
  syserr_too_many_luids_requested,
  syserr_luids_exhausted,
  syserr_invalid_sub_authority,
  syserr_invalid_acl,
  syserr_invalid_sid,
  syserr_invalid_security_descr,
  syserr_bad_inheritance_acl,
  syserr_server_disabled,
  syserr_server_not_disabled,
  syserr_invalid_id_authority,
  syserr_allotted_space_exceeded,
  syserr_invalid_group_attributes,
  syserr_bad_impersonation_level,
  syserr_cant_open_anonymous,
  syserr_bad_validation_class,
  syserr_bad_token_type,
  syserr_no_security_on_object,
  syserr_cant_access_domain_info,
  syserr_invalid_server_state,
  syserr_invalid_domain_state,
  syserr_invalid_domain_role,
  syserr_no_such_domain,
  syserr_domain_exists,
  syserr_domain_limit_exceeded,
  syserr_internal_db_corruption,
  syserr_internal_error,
  syserr_generic_not_mapped,
  syserr_bad_descriptor_format,
  syserr_not_logon_process,
  syserr_logon_session_exists,
  syserr_no_such_package,
  syserr_bad_logon_session_state,
  syserr_logon_session_collision,
  syserr_invalid_logon_type,
  syserr_cannot_impersonate,
  syserr_rxact_invalid_state,
  syserr_rxact_commit_failure,
  syserr_special_account,
  syserr_special_group,
  syserr_special_user,
  syserr_members_primary_group,
  syserr_token_already_in_use,
  syserr_no_such_alias,
  syserr_member_not_in_alias,
  syserr_member_in_alias,
  syserr_alias_exists,
  syserr_logon_not_granted,
  syserr_too_many_secrets,
  syserr_secret_too_long,
  syserr_internal_db_error,
  syserr_too_many_context_ids,
  syserr_logon_type_not_granted,
  syserr_nt_cross_encryption_required,
  syserr_no_such_member,
  syserr_invalid_member,
  syserr_too_many_sids,
  syserr_lm_cross_encryption_required,
  syserr_no_inheritance,
  syserr_file_corrupt,
  syserr_disk_corrupt,
  syserr_no_user_session_key,
  syserr_license_quota_exceeded,
  syserr_invalid_window_handle,
  syserr_invalid_menu_handle,
  syserr_invalid_cursor_handle,
  syserr_invalid_accel_handle,
  syserr_invalid_hook_handle,
  syserr_invalid_dwp_handle,
  syserr_tlw_with_wschild,
  syserr_cannot_find_wnd_class,
  syserr_window_of_other_thread,
  syserr_hotkey_already_registered,
  syserr_class_already_exists,
  syserr_class_does_not_exist,
  syserr_class_has_windows,
  syserr_invalid_index,
  syserr_invalid_icon_handle,
  syserr_private_dialog_index,
  syserr_listbox_id_not_found,
  syserr_no_wildcard_characters,
  syserr_clipboard_not_open,
  syserr_hotkey_not_registered,
  syserr_window_not_dialog,
  syserr_control_id_not_found,
  syserr_invalid_combobox_message,
  syserr_window_not_combobox,
  syserr_invalid_edit_height,
  syserr_dc_not_found,
  syserr_invalid_hook_filter,
  syserr_invalid_filter_proc,
  syserr_hook_needs_hmod,
  syserr_global_only_hook,
  syserr_journal_hook_set,
  syserr_hook_not_installed,
  syserr_invalid_lb_message,
  syserr_setcount_on_bad_lb,
  syserr_lb_without_tabstops,
  syserr_destroy_object_of_other_thread,
  syserr_child_window_menu,
  syserr_no_system_menu,
  syserr_invalid_msgbox_style,
  syserr_invalid_spi_value,
  syserr_screen_already_locked,
  syserr_hwnds_have_diff_parent,
  syserr_not_child_window,
  syserr_invalid_gw_command,
  syserr_invalid_thread_id,
  syserr_non_mdichild_window,
  syserr_popup_already_active,
  syserr_no_scrollbars,
  syserr_invalid_scrollbar_range,
  syserr_invalid_showwin_command,
  syserr_no_system_resources,
  syserr_nonpaged_system_resources,
  syserr_paged_system_resources,
  syserr_working_set_quota,
  syserr_pagefile_quota,
  syserr_commitment_limit,
  syserr_menu_item_not_found,
  syserr_eventlog_file_corrupt,
  syserr_eventlog_cant_start,
  syserr_log_file_full,
  syserr_eventlog_file_changed,
  syserr_rpc_s_invalid_string_binding,
  syserr_rpc_s_wrong_kind_of_binding,
  syserr_rpc_s_invalid_binding,
  syserr_rpc_s_protseq_not_supported,
  syserr_rpc_s_invalid_rpc_protseq,
  syserr_rpc_s_invalid_string_uuid,
  syserr_rpc_s_invalid_endpoint_format,
  syserr_rpc_s_invalid_net_addr,
  syserr_rpc_s_no_endpoint_found,
  syserr_rpc_s_invalid_timeout,
  syserr_rpc_s_object_not_found,
  syserr_rpc_s_already_registered,
  syserr_rpc_s_type_already_registered,
  syserr_rpc_s_already_listening,
  syserr_rpc_s_no_protseqs_registered,
  syserr_rpc_s_not_listening,
  syserr_rpc_s_unknown_mgr_type,
  syserr_rpc_s_unknown_if,
  syserr_rpc_s_no_bindings,
  syserr_rpc_s_no_protseqs,
  syserr_rpc_s_cant_create_endpoint,
  syserr_rpc_s_out_of_resources,
  syserr_rpc_s_server_unavailable,
  syserr_rpc_s_server_too_busy,
  syserr_rpc_s_invalid_network_options,
  syserr_rpc_s_no_call_active,
  syserr_rpc_s_call_failed,
  syserr_rpc_s_call_failed_dne,
  syserr_rpc_s_protocol_error,
  syserr_rpc_s_unsupported_trans_syn,
  syserr_rpc_s_unsupported_type,
  syserr_rpc_s_invalid_tag,
  syserr_rpc_s_invalid_bound,
  syserr_rpc_s_no_entry_name,
  syserr_rpc_s_invalid_name_syntax,
  syserr_rpc_s_unsupported_name_syntax,
  syserr_rpc_s_uuid_no_address,
  syserr_rpc_s_duplicate_endpoint,
  syserr_rpc_s_unknown_authn_type,
  syserr_rpc_s_max_calls_too_small,
  syserr_rpc_s_string_too_long,
  syserr_rpc_s_protseq_not_found,
  syserr_rpc_s_procnum_out_of_range,
  syserr_rpc_s_binding_has_no_auth,
  syserr_rpc_s_unknown_authn_service,
  syserr_rpc_s_unknown_authn_level,
  syserr_rpc_s_invalid_auth_identity,
  syserr_rpc_s_unknown_authz_service,
  syserr_ept_s_invalid_entry,
  syserr_ept_s_cant_perform_op,
  syserr_ept_s_not_registered,
  syserr_rpc_s_nothing_to_export,
  syserr_rpc_s_incomplete_name,
  syserr_rpc_s_invalid_vers_option,
  syserr_rpc_s_no_more_members,
  syserr_rpc_s_not_all_objs_unexported,
  syserr_rpc_s_interface_not_found,
  syserr_rpc_s_entry_already_exists,
  syserr_rpc_s_entry_not_found,
  syserr_rpc_s_name_service_unavailable,
  syserr_rpc_s_invalid_naf_id,
  syserr_rpc_s_cannot_support,
  syserr_rpc_s_no_context_available,
  syserr_rpc_s_internal_error,
  syserr_rpc_s_zero_divide,
  syserr_rpc_s_address_error,
  syserr_rpc_s_fp_div_zero,
  syserr_rpc_s_fp_underflow,
  syserr_rpc_s_fp_overflow,
  syserr_rpc_x_no_more_entries,
  syserr_rpc_x_ss_char_trans_open_fail,
  syserr_rpc_x_ss_char_trans_short_file,
  syserr_rpc_x_ss_in_null_context,
  syserr_rpc_x_ss_context_damaged,
  syserr_rpc_x_ss_handles_mismatch,
  syserr_rpc_x_ss_cannot_get_call_handle,
  syserr_rpc_x_null_ref_pointer,
  syserr_rpc_x_enum_value_out_of_range,
  syserr_rpc_x_byte_count_too_small,
  syserr_rpc_x_bad_stub_data,
  syserr_invalid_user_buffer,
  syserr_unrecognized_media,
  syserr_no_trust_lsa_secret,
  syserr_no_trust_sam_account,
  syserr_trusted_domain_failure,
  syserr_trusted_relationship_failure,
  syserr_trust_failure,
  syserr_rpc_s_call_in_progress,
  syserr_netlogon_not_started,
  syserr_account_expired,
  syserr_redirector_has_open_handles,
  syserr_printer_driver_already_installed,
  syserr_unknown_port,
  syserr_unknown_printer_driver,
  syserr_unknown_printprocessor,
  syserr_invalid_separator_file,
  syserr_invalid_priority,
  syserr_invalid_printer_name,
  syserr_printer_already_exists,
  syserr_invalid_printer_command,
  syserr_invalid_datatype,
  syserr_invalid_environment,
  syserr_rpc_s_no_more_bindings,
  syserr_nologon_interdomain_trust_account,
  syserr_nologon_workstation_trust_account,
  syserr_nologon_server_trust_account,
  syserr_domain_trust_inconsistent,
  syserr_server_has_open_handles,
  syserr_resource_data_not_found,
  syserr_resource_type_not_found,
  syserr_resource_name_not_found,
  syserr_resource_lang_not_found,
  syserr_not_enough_quota,
  syserr_rpc_s_no_interfaces,
  syserr_rpc_s_call_cancelled,
  syserr_rpc_s_binding_incomplete,
  syserr_rpc_s_comm_failure,
  syserr_rpc_s_unsupported_authn_level,
  syserr_rpc_s_no_princ_name,
  syserr_rpc_s_not_rpc_error,
  syserr_rpc_s_uuid_local_only,
  syserr_rpc_s_sec_pkg_error,
  syserr_rpc_s_not_cancelled,
  syserr_rpc_x_invalid_es_action,
  syserr_rpc_x_wrong_es_version,
  syserr_rpc_x_wrong_stub_version,
  syserr_rpc_s_group_member_not_found,
  syserr_ept_s_cant_create,
  syserr_rpc_s_invalid_object,
  syserr_invalid_time,
  syserr_invalid_form_name,
  syserr_invalid_form_size,
  syserr_already_waiting,
  syserr_printer_deleted,
  syserr_invalid_printer_state,
  syserr_password_must_change,
  syserr_domain_controller_not_found,
  syserr_account_locked_out,
  syserr_no_browser_servers_found,
  syserr_invalid_pixel_format,
  syserr_bad_driver,
  syserr_invalid_window_style,
  syserr_metafile_not_supported,
  syserr_transform_not_supported,
  syserr_clipping_not_supported,
  syserr_unknown_print_monitor,
  syserr_printer_driver_in_use,
  syserr_spool_file_not_found,
  syserr_spl_no_startdoc,
  syserr_spl_no_addjob,
  syserr_print_processor_already_installed,
  syserr_print_monitor_already_installed,
  syserr_wins_internal,
  syserr_can_not_del_local_wins,
  syserr_static_init,
  syserr_inc_backup,
  syserr_full_backup,
  syserr_rec_non_existent,
  syserr_rpl_not_allowed,

  /* Winsock error codes: */
  syserr_wsaeintr,
  syserr_wsaebadf,
  syserr_wsaeacces,
  syserr_wsaefault,
  syserr_wsaeinval,
  syserr_wsaemfile,
  syserr_wsaewouldblock,
  syserr_wsaeinprogress,
  syserr_wsaealready,
  syserr_wsaenotsock,
  syserr_wsaedestaddrreq,
  syserr_wsaemsgsize,
  syserr_wsaeprototype,
  syserr_wsaenoprotoopt,
  syserr_wsaeprotonosupport,
  syserr_wsaesocktnosupport,
  syserr_wsaeopnotsupp,
  syserr_wsaepfnosupport,
  syserr_wsaeafnosupport,
  syserr_wsaeaddrinuse,
  syserr_wsaeaddrnotavail,
  syserr_wsaenetdown,
  syserr_wsaenetunreach,
  syserr_wsaenetreset,
  syserr_wsaeconnaborted,
  syserr_wsaeconnreset,
  syserr_wsaenobufs,
  syserr_wsaeisconn,
  syserr_wsaenotconn,
  syserr_wsaeshutdown,
  syserr_wsaetoomanyrefs,
  syserr_wsaetimedout,
  syserr_wsaeconnrefused,
  syserr_wsaeloop,
  syserr_wsaenametoolong,
  syserr_wsaehostdown,
  syserr_wsaehostunreach,
  syserr_wsaenotempty,
  syserr_wsaeproclim,
  syserr_wsaeusers,
  syserr_wsaedquot,
  syserr_wsaestale,
  syserr_wsaeremote,
  syserr_wsaediscon,
  syserr_wsasysnotready,
  syserr_wsavernotsupported,
  syserr_wsanotinitialised,
  syserr_wsahost_not_found,
  syserr_wsatry_again,
  syserr_wsano_recovery,
  syserr_wsano_data,

  /* Unix error codes: */
#define FIRST_UNIX_ERROR_CODE syserr_arg_list_too_long
  syserr_arg_list_too_long,
  syserr_bad_file_descriptor,
  syserr_domain_error,
  syserr_exec_format_error,
  syserr_unix_file_exists,
  syserr_interrupted_function_call,
  syserr_invalid_argument,
  syserr_no_such_file_or_directory,
  syserr_not_a_directory,
  syserr_not_enough_space,
  syserr_permission_denied,
  syserr_resource_deadlock_avoided,
  syserr_resource_temporarily_unavailable,
  syserr_result_too_large,
  syserr_unix_too_many_open_files,

  syserr_unknown
};

#else /* not DEFINE_WIN32_SYSCALLS */

extern void NT_prim_check_errno (enum syscall_names);
extern void NT_error_api_call (DWORD, enum syscall_names);
extern void NT_error_unix_call (int, enum syscall_names);

#define STD_VOID_UNIX_CALL(proc, args)					\
{									\
  while ((proc args) < 0)						\
    if (errno != EINTR)							\
      NT_error_unix_call (errno, syscall_ ## proc);			\
}

#define STD_UINT_UNIX_CALL(result, proc, args)				\
{									\
  if (((result) = (proc args)) == 0)					\
    NT_error_unix_call (errno, syscall_ ## proc);			\
}

#define STD_PTR_UNIX_CALL(result, proc, args)				\
{									\
  if (((result) = (proc args)) == 0)					\
    NT_error_unix_call (errno, syscall_ ## proc);			\
}

#define STD_BOOL_API_CALL(proc, args)					\
{									\
  if (! (proc args))							\
    NT_error_api_call ((GetLastError ()), apicall_ ## proc);		\
}

#define STD_HANDLE_API_CALL(result, proc, args)				\
{									\
  if (((result) = (proc args)) == INVALID_HANDLE_VALUE)			\
    NT_error_api_call ((GetLastError ()), apicall_ ## proc);		\
}

#ifdef SCM_NTTOP_C

static char * syscall_names_table [] =
{
  /* Native Win32 API procedures: */
  "CLOSE-HANDLE",
  "COPY-FILE",
  "CREATE-DIRECTORY",
  "CREATE-FILE",
  "CREATE-PIPE",
  "CREATE-PROCESS",
  "DELETE-FILE",
  "DUPLICATE-HANDLE",
  "ENUM-WINDOWS",
  "EXPAND-ENVIRONMENT-STRINGS",
  "FIND-FIRST-FILE",
  "GET-EXIT-CODE-PROCESS",
  "GET-FILE-ATTRIBUTES",
  "GET-FILE-INFORMATION-BY-HANDLE",
  "GET-FILE-SIZE",
  "GET-FILE-TIME",
  "GET-KEYBOARD-STATE",
  "GET-STD-HANDLE",
  "INITIALIZE-SECURITY-DESCRIPTOR",
  "MOVE-FILE",
  "MSG-WAIT-FOR-MULTIPLE-OBJECTS",
  "PEEK-NAMED-PIPE",
  "READ-FILE",
  "REG-CLOSE-KEY",
  "REG-CREATE-KEY-EX",
  "REG-DELETE-KEY",
  "REG-DELETE-VALUE",
  "REG-ENUM-KEY-EX",
  "REG-ENUM-VALUE",
  "REG-OPEN-KEY-EX",
  "REG-QUERY-INFO-KEY",
  "REG-QUERY-VALUE-EX",
  "REG-SET-VALUE-EX",
  "REMOVE-DIRECTORY",
  "SET-CURRENT-DIRECTORY",
  "SET-FILE-ATTRIBUTES",
  "SET-FILE-POINTER",
  "SET-FILE-TIME",
  "SET-KEYBOARD-STATE",
  "SET-SECURITY-DESCRIPTOR-DACL",
  "SET-STD-HANDLE",
  "SET-TIMER",
  "TERMINATE-PROCESS",
  "WAIT-FOR-MULTIPLE-OBJECTS",
  "WAIT-FOR-SINGLE-OBJECT",
  "WRITE-FILE",

  /* Winsock procedures: */
  "ACCEPT",
  "BIND",
  "CLOSE-SOCKET",
  "CONNECT",
  "GET-HOST-BY-NAME",
  "GET-HOST-NAME",
  "IOCTL-SOCKET",
  "LISTEN",
  "RECV",
  "SEND",
  "SOCKET",

  /* C Library's unix-style procedures: */
  "CLOSE",
  "FSTAT",
  "GETCWD",
  "GMTIME",
  "LOCALTIME",
  "LSEEK",
  "MALLOC",
  "MKDIR",
  "MKTIME",
  "OPEN",
  "READ",
  "REALLOC",
  "RMDIR",
  "STAT",
  "UNLINK",
  "WRITE"
};

/* Machine-generated table, do not edit: */
static char * syserr_names_table [] =
{
  /* Win32 error codes: */
  "SUCCESS",
  "INVALID-FUNCTION",
  "FILE-NOT-FOUND",
  "PATH-NOT-FOUND",
  "TOO-MANY-OPEN-FILES",
  "ACCESS-DENIED",
  "INVALID-HANDLE",
  "ARENA-TRASHED",
  "NOT-ENOUGH-MEMORY",
  "INVALID-BLOCK",
  "BAD-ENVIRONMENT",
  "BAD-FORMAT",
  "INVALID-ACCESS",
  "INVALID-DATA",
  "OUTOFMEMORY",
  "INVALID-DRIVE",
  "CURRENT-DIRECTORY",
  "NOT-SAME-DEVICE",
  "NO-MORE-FILES",
  "WRITE-PROTECT",
  "BAD-UNIT",
  "NOT-READY",
  "BAD-COMMAND",
  "CRC",
  "BAD-LENGTH",
  "SEEK",
  "NOT-DOS-DISK",
  "SECTOR-NOT-FOUND",
  "OUT-OF-PAPER",
  "WRITE-FAULT",
  "READ-FAULT",
  "GEN-FAILURE",
  "SHARING-VIOLATION",
  "LOCK-VIOLATION",
  "WRONG-DISK",
  "SHARING-BUFFER-EXCEEDED",
  "HANDLE-EOF",
  "HANDLE-DISK-FULL",
  "NOT-SUPPORTED",
  "REM-NOT-LIST",
  "DUP-NAME",
  "BAD-NETPATH",
  "NETWORK-BUSY",
  "DEV-NOT-EXIST",
  "TOO-MANY-CMDS",
  "ADAP-HDW-ERR",
  "BAD-NET-RESP",
  "UNEXP-NET-ERR",
  "BAD-REM-ADAP",
  "PRINTQ-FULL",
  "NO-SPOOL-SPACE",
  "PRINT-CANCELLED",
  "NETNAME-DELETED",
  "NETWORK-ACCESS-DENIED",
  "BAD-DEV-TYPE",
  "BAD-NET-NAME",
  "TOO-MANY-NAMES",
  "TOO-MANY-SESS",
  "SHARING-PAUSED",
  "REQ-NOT-ACCEP",
  "REDIR-PAUSED",
  "FILE-EXISTS",
  "CANNOT-MAKE",
  "FAIL-I24",
  "OUT-OF-STRUCTURES",
  "ALREADY-ASSIGNED",
  "INVALID-PASSWORD",
  "INVALID-PARAMETER",
  "NET-WRITE-FAULT",
  "NO-PROC-SLOTS",
  "TOO-MANY-SEMAPHORES",
  "EXCL-SEM-ALREADY-OWNED",
  "SEM-IS-SET",
  "TOO-MANY-SEM-REQUESTS",
  "INVALID-AT-INTERRUPT-TIME",
  "SEM-OWNER-DIED",
  "SEM-USER-LIMIT",
  "DISK-CHANGE",
  "DRIVE-LOCKED",
  "BROKEN-PIPE",
  "OPEN-FAILED",
  "BUFFER-OVERFLOW",
  "DISK-FULL",
  "NO-MORE-SEARCH-HANDLES",
  "INVALID-TARGET-HANDLE",
  "INVALID-CATEGORY",
  "INVALID-VERIFY-SWITCH",
  "BAD-DRIVER-LEVEL",
  "CALL-NOT-IMPLEMENTED",
  "SEM-TIMEOUT",
  "INSUFFICIENT-BUFFER",
  "INVALID-NAME",
  "INVALID-LEVEL",
  "NO-VOLUME-LABEL",
  "MOD-NOT-FOUND",
  "PROC-NOT-FOUND",
  "WAIT-NO-CHILDREN",
  "CHILD-NOT-COMPLETE",
  "DIRECT-ACCESS-HANDLE",
  "NEGATIVE-SEEK",
  "SEEK-ON-DEVICE",
  "IS-JOIN-TARGET",
  "IS-JOINED",
  "IS-SUBSTED",
  "NOT-JOINED",
  "NOT-SUBSTED",
  "JOIN-TO-JOIN",
  "SUBST-TO-SUBST",
  "JOIN-TO-SUBST",
  "SUBST-TO-JOIN",
  "BUSY-DRIVE",
  "SAME-DRIVE",
  "DIR-NOT-ROOT",
  "DIR-NOT-EMPTY",
  "IS-SUBST-PATH",
  "IS-JOIN-PATH",
  "PATH-BUSY",
  "IS-SUBST-TARGET",
  "SYSTEM-TRACE",
  "INVALID-EVENT-COUNT",
  "TOO-MANY-MUXWAITERS",
  "INVALID-LIST-FORMAT",
  "LABEL-TOO-LONG",
  "TOO-MANY-TCBS",
  "SIGNAL-REFUSED",
  "DISCARDED",
  "NOT-LOCKED",
  "BAD-THREADID-ADDR",
  "BAD-ARGUMENTS",
  "BAD-PATHNAME",
  "SIGNAL-PENDING",
  "MAX-THRDS-REACHED",
  "LOCK-FAILED",
  "BUSY",
  "CANCEL-VIOLATION",
  "ATOMIC-LOCKS-NOT-SUPPORTED",
  "INVALID-SEGMENT-NUMBER",
  "INVALID-ORDINAL",
  "ALREADY-EXISTS",
  "INVALID-FLAG-NUMBER",
  "SEM-NOT-FOUND",
  "INVALID-STARTING-CODESEG",
  "INVALID-STACKSEG",
  "INVALID-MODULETYPE",
  "INVALID-EXE-SIGNATURE",
  "EXE-MARKED-INVALID",
  "BAD-EXE-FORMAT",
  "ITERATED-DATA-EXCEEDS-64k",
  "INVALID-MINALLOCSIZE",
  "DYNLINK-FROM-INVALID-RING",
  "IOPL-NOT-ENABLED",
  "INVALID-SEGDPL",
  "AUTODATASEG-EXCEEDS-64k",
  "RING2SEG-MUST-BE-MOVABLE",
  "RELOC-CHAIN-XEEDS-SEGLIM",
  "INFLOOP-IN-RELOC-CHAIN",
  "ENVVAR-NOT-FOUND",
  "NO-SIGNAL-SENT",
  "FILENAME-EXCED-RANGE",
  "RING2-STACK-IN-USE",
  "META-EXPANSION-TOO-LONG",
  "INVALID-SIGNAL-NUMBER",
  "THREAD-1-INACTIVE",
  "LOCKED",
  "TOO-MANY-MODULES",
  "NESTING-NOT-ALLOWED",
  "BAD-PIPE",
  "PIPE-BUSY",
  "NO-DATA",
  "PIPE-NOT-CONNECTED",
  "MORE-DATA",
  "VC-DISCONNECTED",
  "INVALID-EA-NAME",
  "EA-LIST-INCONSISTENT",
  "NO-MORE-ITEMS",
  "CANNOT-COPY",
  "DIRECTORY",
  "EAS-DIDNT-FIT",
  "EA-FILE-CORRUPT",
  "EA-TABLE-FULL",
  "INVALID-EA-HANDLE",
  "EAS-NOT-SUPPORTED",
  "NOT-OWNER",
  "TOO-MANY-POSTS",
  "PARTIAL-COPY",
  "MR-MID-NOT-FOUND",
  "INVALID-ADDRESS",
  "ARITHMETIC-OVERFLOW",
  "PIPE-CONNECTED",
  "PIPE-LISTENING",
  "EA-ACCESS-DENIED",
  "OPERATION-ABORTED",
  "IO-INCOMPLETE",
  "IO-PENDING",
  "NOACCESS",
  "SWAPERROR",
  "STACK-OVERFLOW",
  "INVALID-MESSAGE",
  "CAN-NOT-COMPLETE",
  "INVALID-FLAGS",
  "UNRECOGNIZED-VOLUME",
  "FILE-INVALID",
  "FULLSCREEN-MODE",
  "NO-TOKEN",
  "BADDB",
  "BADKEY",
  "CANTOPEN",
  "CANTREAD",
  "CANTWRITE",
  "REGISTRY-RECOVERED",
  "REGISTRY-CORRUPT",
  "REGISTRY-IO-FAILED",
  "NOT-REGISTRY-FILE",
  "KEY-DELETED",
  "NO-LOG-SPACE",
  "KEY-HAS-CHILDREN",
  "CHILD-MUST-BE-VOLATILE",
  "NOTIFY-ENUM-DIR",
  "DEPENDENT-SERVICES-RUNNING",
  "INVALID-SERVICE-CONTROL",
  "SERVICE-REQUEST-TIMEOUT",
  "SERVICE-NO-THREAD",
  "SERVICE-DATABASE-LOCKED",
  "SERVICE-ALREADY-RUNNING",
  "INVALID-SERVICE-ACCOUNT",
  "SERVICE-DISABLED",
  "CIRCULAR-DEPENDENCY",
  "SERVICE-DOES-NOT-EXIST",
  "SERVICE-CANNOT-ACCEPT-CTRL",
  "SERVICE-NOT-ACTIVE",
  "FAILED-SERVICE-CONTROLLER-CONNECT",
  "EXCEPTION-IN-SERVICE",
  "DATABASE-DOES-NOT-EXIST",
  "SERVICE-SPECIFIC-ERROR",
  "PROCESS-ABORTED",
  "SERVICE-DEPENDENCY-FAIL",
  "SERVICE-LOGON-FAILED",
  "SERVICE-START-HANG",
  "INVALID-SERVICE-LOCK",
  "SERVICE-MARKED-FOR-DELETE",
  "SERVICE-EXISTS",
  "ALREADY-RUNNING-LKG",
  "SERVICE-DEPENDENCY-DELETED",
  "BOOT-ALREADY-ACCEPTED",
  "SERVICE-NEVER-STARTED",
  "DUPLICATE-SERVICE-NAME",
  "END-OF-MEDIA",
  "FILEMARK-DETECTED",
  "BEGINNING-OF-MEDIA",
  "SETMARK-DETECTED",
  "NO-DATA-DETECTED",
  "PARTITION-FAILURE",
  "INVALID-BLOCK-LENGTH",
  "DEVICE-NOT-PARTITIONED",
  "UNABLE-TO-LOCK-MEDIA",
  "UNABLE-TO-UNLOAD-MEDIA",
  "MEDIA-CHANGED",
  "BUS-RESET",
  "NO-MEDIA-IN-DRIVE",
  "NO-UNICODE-TRANSLATION",
  "DLL-INIT-FAILED",
  "SHUTDOWN-IN-PROGRESS",
  "NO-SHUTDOWN-IN-PROGRESS",
  "IO-DEVICE",
  "SERIAL-NO-DEVICE",
  "IRQ-BUSY",
  "MORE-WRITES",
  "COUNTER-TIMEOUT",
  "FLOPPY-ID-MARK-NOT-FOUND",
  "FLOPPY-WRONG-CYLINDER",
  "FLOPPY-UNKNOWN-ERROR",
  "FLOPPY-BAD-REGISTERS",
  "DISK-RECALIBRATE-FAILED",
  "DISK-OPERATION-FAILED",
  "DISK-RESET-FAILED",
  "EOM-OVERFLOW",
  "NOT-ENOUGH-SERVER-MEMORY",
  "POSSIBLE-DEADLOCK",
  "MAPPED-ALIGNMENT",
  "SET-POWER-STATE-VETOED",
  "SET-POWER-STATE-FAILED",
  "OLD-WIN-VERSION",
  "APP-WRONG-OS",
  "SINGLE-INSTANCE-APP",
  "RMODE-APP",
  "INVALID-DLL",
  "NO-ASSOCIATION",
  "DDE-FAIL",
  "DLL-NOT-FOUND",
  "BAD-USERNAME",
  "NOT-CONNECTED",
  "OPEN-FILES",
  "ACTIVE-CONNECTIONS",
  "DEVICE-IN-USE",
  "BAD-DEVICE",
  "CONNECTION-UNAVAIL",
  "DEVICE-ALREADY-REMEMBERED",
  "NO-NET-OR-BAD-PATH",
  "BAD-PROVIDER",
  "CANNOT-OPEN-PROFILE",
  "BAD-PROFILE",
  "NOT-CONTAINER",
  "EXTENDED-ERROR",
  "INVALID-GROUPNAME",
  "INVALID-COMPUTERNAME",
  "INVALID-EVENTNAME",
  "INVALID-DOMAINNAME",
  "INVALID-SERVICENAME",
  "INVALID-NETNAME",
  "INVALID-SHARENAME",
  "INVALID-PASSWORDNAME",
  "INVALID-MESSAGENAME",
  "INVALID-MESSAGEDEST",
  "SESSION-CREDENTIAL-CONFLICT",
  "REMOTE-SESSION-LIMIT-EXCEEDED",
  "DUP-DOMAINNAME",
  "NO-NETWORK",
  "CANCELLED",
  "USER-MAPPED-FILE",
  "CONNECTION-REFUSED",
  "GRACEFUL-DISCONNECT",
  "ADDRESS-ALREADY-ASSOCIATED",
  "ADDRESS-NOT-ASSOCIATED",
  "CONNECTION-INVALID",
  "CONNECTION-ACTIVE",
  "NETWORK-UNREACHABLE",
  "HOST-UNREACHABLE",
  "PROTOCOL-UNREACHABLE",
  "PORT-UNREACHABLE",
  "REQUEST-ABORTED",
  "CONNECTION-ABORTED",
  "RETRY",
  "CONNECTION-COUNT-LIMIT",
  "LOGIN-TIME-RESTRICTION",
  "LOGIN-WKSTA-RESTRICTION",
  "INCORRECT-ADDRESS",
  "ALREADY-REGISTERED",
  "SERVICE-NOT-FOUND",
  "NOT-AUTHENTICATED",
  "NOT-LOGGED-ON",
  "CONTINUE",
  "ALREADY-INITIALIZED",
  "NO-MORE-DEVICES",
  "NOT-ALL-ASSIGNED",
  "SOME-NOT-MAPPED",
  "NO-QUOTAS-FOR-ACCOUNT",
  "LOCAL-USER-SESSION-KEY",
  "NULL-LM-PASSWORD",
  "UNKNOWN-REVISION",
  "REVISION-MISMATCH",
  "INVALID-OWNER",
  "INVALID-PRIMARY-GROUP",
  "NO-IMPERSONATION-TOKEN",
  "CANT-DISABLE-MANDATORY",
  "NO-LOGON-SERVERS",
  "NO-SUCH-LOGON-SESSION",
  "NO-SUCH-PRIVILEGE",
  "PRIVILEGE-NOT-HELD",
  "INVALID-ACCOUNT-NAME",
  "USER-EXISTS",
  "NO-SUCH-USER",
  "GROUP-EXISTS",
  "NO-SUCH-GROUP",
  "MEMBER-IN-GROUP",
  "MEMBER-NOT-IN-GROUP",
  "LAST-ADMIN",
  "WRONG-PASSWORD",
  "ILL-FORMED-PASSWORD",
  "PASSWORD-RESTRICTION",
  "LOGON-FAILURE",
  "ACCOUNT-RESTRICTION",
  "INVALID-LOGON-HOURS",
  "INVALID-WORKSTATION",
  "PASSWORD-EXPIRED",
  "ACCOUNT-DISABLED",
  "NONE-MAPPED",
  "TOO-MANY-LUIDS-REQUESTED",
  "LUIDS-EXHAUSTED",
  "INVALID-SUB-AUTHORITY",
  "INVALID-ACL",
  "INVALID-SID",
  "INVALID-SECURITY-DESCR",
  "BAD-INHERITANCE-ACL",
  "SERVER-DISABLED",
  "SERVER-NOT-DISABLED",
  "INVALID-ID-AUTHORITY",
  "ALLOTTED-SPACE-EXCEEDED",
  "INVALID-GROUP-ATTRIBUTES",
  "BAD-IMPERSONATION-LEVEL",
  "CANT-OPEN-ANONYMOUS",
  "BAD-VALIDATION-CLASS",
  "BAD-TOKEN-TYPE",
  "NO-SECURITY-ON-OBJECT",
  "CANT-ACCESS-DOMAIN-INFO",
  "INVALID-SERVER-STATE",
  "INVALID-DOMAIN-STATE",
  "INVALID-DOMAIN-ROLE",
  "NO-SUCH-DOMAIN",
  "DOMAIN-EXISTS",
  "DOMAIN-LIMIT-EXCEEDED",
  "INTERNAL-DB-CORRUPTION",
  "INTERNAL-ERROR",
  "GENERIC-NOT-MAPPED",
  "BAD-DESCRIPTOR-FORMAT",
  "NOT-LOGON-PROCESS",
  "LOGON-SESSION-EXISTS",
  "NO-SUCH-PACKAGE",
  "BAD-LOGON-SESSION-STATE",
  "LOGON-SESSION-COLLISION",
  "INVALID-LOGON-TYPE",
  "CANNOT-IMPERSONATE",
  "RXACT-INVALID-STATE",
  "RXACT-COMMIT-FAILURE",
  "SPECIAL-ACCOUNT",
  "SPECIAL-GROUP",
  "SPECIAL-USER",
  "MEMBERS-PRIMARY-GROUP",
  "TOKEN-ALREADY-IN-USE",
  "NO-SUCH-ALIAS",
  "MEMBER-NOT-IN-ALIAS",
  "MEMBER-IN-ALIAS",
  "ALIAS-EXISTS",
  "LOGON-NOT-GRANTED",
  "TOO-MANY-SECRETS",
  "SECRET-TOO-LONG",
  "INTERNAL-DB-ERROR",
  "TOO-MANY-CONTEXT-IDS",
  "LOGON-TYPE-NOT-GRANTED",
  "NT-CROSS-ENCRYPTION-REQUIRED",
  "NO-SUCH-MEMBER",
  "INVALID-MEMBER",
  "TOO-MANY-SIDS",
  "LM-CROSS-ENCRYPTION-REQUIRED",
  "NO-INHERITANCE",
  "FILE-CORRUPT",
  "DISK-CORRUPT",
  "NO-USER-SESSION-KEY",
  "LICENSE-QUOTA-EXCEEDED",
  "INVALID-WINDOW-HANDLE",
  "INVALID-MENU-HANDLE",
  "INVALID-CURSOR-HANDLE",
  "INVALID-ACCEL-HANDLE",
  "INVALID-HOOK-HANDLE",
  "INVALID-DWP-HANDLE",
  "TLW-WITH-WSCHILD",
  "CANNOT-FIND-WND-CLASS",
  "WINDOW-OF-OTHER-THREAD",
  "HOTKEY-ALREADY-REGISTERED",
  "CLASS-ALREADY-EXISTS",
  "CLASS-DOES-NOT-EXIST",
  "CLASS-HAS-WINDOWS",
  "INVALID-INDEX",
  "INVALID-ICON-HANDLE",
  "PRIVATE-DIALOG-INDEX",
  "LISTBOX-ID-NOT-FOUND",
  "NO-WILDCARD-CHARACTERS",
  "CLIPBOARD-NOT-OPEN",
  "HOTKEY-NOT-REGISTERED",
  "WINDOW-NOT-DIALOG",
  "CONTROL-ID-NOT-FOUND",
  "INVALID-COMBOBOX-MESSAGE",
  "WINDOW-NOT-COMBOBOX",
  "INVALID-EDIT-HEIGHT",
  "DC-NOT-FOUND",
  "INVALID-HOOK-FILTER",
  "INVALID-FILTER-PROC",
  "HOOK-NEEDS-HMOD",
  "GLOBAL-ONLY-HOOK",
  "JOURNAL-HOOK-SET",
  "HOOK-NOT-INSTALLED",
  "INVALID-LB-MESSAGE",
  "SETCOUNT-ON-BAD-LB",
  "LB-WITHOUT-TABSTOPS",
  "DESTROY-OBJECT-OF-OTHER-THREAD",
  "CHILD-WINDOW-MENU",
  "NO-SYSTEM-MENU",
  "INVALID-MSGBOX-STYLE",
  "INVALID-SPI-VALUE",
  "SCREEN-ALREADY-LOCKED",
  "HWNDS-HAVE-DIFF-PARENT",
  "NOT-CHILD-WINDOW",
  "INVALID-GW-COMMAND",
  "INVALID-THREAD-ID",
  "NON-MDICHILD-WINDOW",
  "POPUP-ALREADY-ACTIVE",
  "NO-SCROLLBARS",
  "INVALID-SCROLLBAR-RANGE",
  "INVALID-SHOWWIN-COMMAND",
  "NO-SYSTEM-RESOURCES",
  "NONPAGED-SYSTEM-RESOURCES",
  "PAGED-SYSTEM-RESOURCES",
  "WORKING-SET-QUOTA",
  "PAGEFILE-QUOTA",
  "COMMITMENT-LIMIT",
  "MENU-ITEM-NOT-FOUND",
  "EVENTLOG-FILE-CORRUPT",
  "EVENTLOG-CANT-START",
  "LOG-FILE-FULL",
  "EVENTLOG-FILE-CHANGED",
  "RPC-S-INVALID-STRING-BINDING",
  "RPC-S-WRONG-KIND-OF-BINDING",
  "RPC-S-INVALID-BINDING",
  "RPC-S-PROTSEQ-NOT-SUPPORTED",
  "RPC-S-INVALID-RPC-PROTSEQ",
  "RPC-S-INVALID-STRING-UUID",
  "RPC-S-INVALID-ENDPOINT-FORMAT",
  "RPC-S-INVALID-NET-ADDR",
  "RPC-S-NO-ENDPOINT-FOUND",
  "RPC-S-INVALID-TIMEOUT",
  "RPC-S-OBJECT-NOT-FOUND",
  "RPC-S-ALREADY-REGISTERED",
  "RPC-S-TYPE-ALREADY-REGISTERED",
  "RPC-S-ALREADY-LISTENING",
  "RPC-S-NO-PROTSEQS-REGISTERED",
  "RPC-S-NOT-LISTENING",
  "RPC-S-UNKNOWN-MGR-TYPE",
  "RPC-S-UNKNOWN-IF",
  "RPC-S-NO-BINDINGS",
  "RPC-S-NO-PROTSEQS",
  "RPC-S-CANT-CREATE-ENDPOINT",
  "RPC-S-OUT-OF-RESOURCES",
  "RPC-S-SERVER-UNAVAILABLE",
  "RPC-S-SERVER-TOO-BUSY",
  "RPC-S-INVALID-NETWORK-OPTIONS",
  "RPC-S-NO-CALL-ACTIVE",
  "RPC-S-CALL-FAILED",
  "RPC-S-CALL-FAILED-DNE",
  "RPC-S-PROTOCOL-ERROR",
  "RPC-S-UNSUPPORTED-TRANS-SYN",
  "RPC-S-UNSUPPORTED-TYPE",
  "RPC-S-INVALID-TAG",
  "RPC-S-INVALID-BOUND",
  "RPC-S-NO-ENTRY-NAME",
  "RPC-S-INVALID-NAME-SYNTAX",
  "RPC-S-UNSUPPORTED-NAME-SYNTAX",
  "RPC-S-UUID-NO-ADDRESS",
  "RPC-S-DUPLICATE-ENDPOINT",
  "RPC-S-UNKNOWN-AUTHN-TYPE",
  "RPC-S-MAX-CALLS-TOO-SMALL",
  "RPC-S-STRING-TOO-LONG",
  "RPC-S-PROTSEQ-NOT-FOUND",
  "RPC-S-PROCNUM-OUT-OF-RANGE",
  "RPC-S-BINDING-HAS-NO-AUTH",
  "RPC-S-UNKNOWN-AUTHN-SERVICE",
  "RPC-S-UNKNOWN-AUTHN-LEVEL",
  "RPC-S-INVALID-AUTH-IDENTITY",
  "RPC-S-UNKNOWN-AUTHZ-SERVICE",
  "EPT-S-INVALID-ENTRY",
  "EPT-S-CANT-PERFORM-OP",
  "EPT-S-NOT-REGISTERED",
  "RPC-S-NOTHING-TO-EXPORT",
  "RPC-S-INCOMPLETE-NAME",
  "RPC-S-INVALID-VERS-OPTION",
  "RPC-S-NO-MORE-MEMBERS",
  "RPC-S-NOT-ALL-OBJS-UNEXPORTED",
  "RPC-S-INTERFACE-NOT-FOUND",
  "RPC-S-ENTRY-ALREADY-EXISTS",
  "RPC-S-ENTRY-NOT-FOUND",
  "RPC-S-NAME-SERVICE-UNAVAILABLE",
  "RPC-S-INVALID-NAF-ID",
  "RPC-S-CANNOT-SUPPORT",
  "RPC-S-NO-CONTEXT-AVAILABLE",
  "RPC-S-INTERNAL-ERROR",
  "RPC-S-ZERO-DIVIDE",
  "RPC-S-ADDRESS-ERROR",
  "RPC-S-FP-DIV-ZERO",
  "RPC-S-FP-UNDERFLOW",
  "RPC-S-FP-OVERFLOW",
  "RPC-X-NO-MORE-ENTRIES",
  "RPC-X-SS-CHAR-TRANS-OPEN-FAIL",
  "RPC-X-SS-CHAR-TRANS-SHORT-FILE",
  "RPC-X-SS-IN-NULL-CONTEXT",
  "RPC-X-SS-CONTEXT-DAMAGED",
  "RPC-X-SS-HANDLES-MISMATCH",
  "RPC-X-SS-CANNOT-GET-CALL-HANDLE",
  "RPC-X-NULL-REF-POINTER",
  "RPC-X-ENUM-VALUE-OUT-OF-RANGE",
  "RPC-X-BYTE-COUNT-TOO-SMALL",
  "RPC-X-BAD-STUB-DATA",
  "INVALID-USER-BUFFER",
  "UNRECOGNIZED-MEDIA",
  "NO-TRUST-LSA-SECRET",
  "NO-TRUST-SAM-ACCOUNT",
  "TRUSTED-DOMAIN-FAILURE",
  "TRUSTED-RELATIONSHIP-FAILURE",
  "TRUST-FAILURE",
  "RPC-S-CALL-IN-PROGRESS",
  "NETLOGON-NOT-STARTED",
  "ACCOUNT-EXPIRED",
  "REDIRECTOR-HAS-OPEN-HANDLES",
  "PRINTER-DRIVER-ALREADY-INSTALLED",
  "UNKNOWN-PORT",
  "UNKNOWN-PRINTER-DRIVER",
  "UNKNOWN-PRINTPROCESSOR",
  "INVALID-SEPARATOR-FILE",
  "INVALID-PRIORITY",
  "INVALID-PRINTER-NAME",
  "PRINTER-ALREADY-EXISTS",
  "INVALID-PRINTER-COMMAND",
  "INVALID-DATATYPE",
  "INVALID-ENVIRONMENT",
  "RPC-S-NO-MORE-BINDINGS",
  "NOLOGON-INTERDOMAIN-TRUST-ACCOUNT",
  "NOLOGON-WORKSTATION-TRUST-ACCOUNT",
  "NOLOGON-SERVER-TRUST-ACCOUNT",
  "DOMAIN-TRUST-INCONSISTENT",
  "SERVER-HAS-OPEN-HANDLES",
  "RESOURCE-DATA-NOT-FOUND",
  "RESOURCE-TYPE-NOT-FOUND",
  "RESOURCE-NAME-NOT-FOUND",
  "RESOURCE-LANG-NOT-FOUND",
  "NOT-ENOUGH-QUOTA",
  "RPC-S-NO-INTERFACES",
  "RPC-S-CALL-CANCELLED",
  "RPC-S-BINDING-INCOMPLETE",
  "RPC-S-COMM-FAILURE",
  "RPC-S-UNSUPPORTED-AUTHN-LEVEL",
  "RPC-S-NO-PRINC-NAME",
  "RPC-S-NOT-RPC-ERROR",
  "RPC-S-UUID-LOCAL-ONLY",
  "RPC-S-SEC-PKG-ERROR",
  "RPC-S-NOT-CANCELLED",
  "RPC-X-INVALID-ES-ACTION",
  "RPC-X-WRONG-ES-VERSION",
  "RPC-X-WRONG-STUB-VERSION",
  "RPC-S-GROUP-MEMBER-NOT-FOUND",
  "EPT-S-CANT-CREATE",
  "RPC-S-INVALID-OBJECT",
  "INVALID-TIME",
  "INVALID-FORM-NAME",
  "INVALID-FORM-SIZE",
  "ALREADY-WAITING",
  "PRINTER-DELETED",
  "INVALID-PRINTER-STATE",
  "PASSWORD-MUST-CHANGE",
  "DOMAIN-CONTROLLER-NOT-FOUND",
  "ACCOUNT-LOCKED-OUT",
  "NO-BROWSER-SERVERS-FOUND",
  "INVALID-PIXEL-FORMAT",
  "BAD-DRIVER",
  "INVALID-WINDOW-STYLE",
  "METAFILE-NOT-SUPPORTED",
  "TRANSFORM-NOT-SUPPORTED",
  "CLIPPING-NOT-SUPPORTED",
  "UNKNOWN-PRINT-MONITOR",
  "PRINTER-DRIVER-IN-USE",
  "SPOOL-FILE-NOT-FOUND",
  "SPL-NO-STARTDOC",
  "SPL-NO-ADDJOB",
  "PRINT-PROCESSOR-ALREADY-INSTALLED",
  "PRINT-MONITOR-ALREADY-INSTALLED",
  "WINS-INTERNAL",
  "CAN-NOT-DEL-LOCAL-WINS",
  "STATIC-INIT",
  "INC-BACKUP",
  "FULL-BACKUP",
  "REC-NON-EXISTENT",
  "RPL-NOT-ALLOWED",

  /* Winsock error codes: */
  "WSAEINTR",
  "WSAEBADF",
  "WSAEACCES",
  "WSAEFAULT",
  "WSAEINVAL",
  "WSAEMFILE",
  "WSAEWOULDBLOCK",
  "WSAEINPROGRESS",
  "WSAEALREADY",
  "WSAENOTSOCK",
  "WSAEDESTADDRREQ",
  "WSAEMSGSIZE",
  "WSAEPROTOTYPE",
  "WSAENOPROTOOPT",
  "WSAEPROTONOSUPPORT",
  "WSAESOCKTNOSUPPORT",
  "WSAEOPNOTSUPP",
  "WSAEPFNOSUPPORT",
  "WSAEAFNOSUPPORT",
  "WSAEADDRINUSE",
  "WSAEADDRNOTAVAIL",
  "WSAENETDOWN",
  "WSAENETUNREACH",
  "WSAENETRESET",
  "WSAECONNABORTED",
  "WSAECONNRESET",
  "WSAENOBUFS",
  "WSAEISCONN",
  "WSAENOTCONN",
  "WSAESHUTDOWN",
  "WSAETOOMANYREFS",
  "WSAETIMEDOUT",
  "WSAECONNREFUSED",
  "WSAELOOP",
  "WSAENAMETOOLONG",
  "WSAEHOSTDOWN",
  "WSAEHOSTUNREACH",
  "WSAENOTEMPTY",
  "WSAEPROCLIM",
  "WSAEUSERS",
  "WSAEDQUOT",
  "WSAESTALE",
  "WSAEREMOTE",
  "WSAEDISCON",
  "WSASYSNOTREADY",
  "WSAVERNOTSUPPORTED",
  "WSANOTINITIALISED",
  "WSAHOST_NOT_FOUND",
  "WSATRY_AGAIN",
  "WSANO_RECOVERY",
  "WSANO_DATA",

  /* Unix error codes: */
  "ARG-LIST-TOO-LONG",
  "BAD-FILE-DESCRIPTOR",
  "DOMAIN-ERROR",
  "EXEC-FORMAT-ERROR",
  "FILE-EXISTS",
  "INTERRUPTED-FUNCTION-CALL",
  "INVALID-ARGUMENT",
  "NO-SUCH-FILE-OR-DIRECTORY",
  "NOT-A-DIRECTORY",
  "NOT-ENOUGH-SPACE",
  "PERMISSION-DENIED",
  "RESOURCE-DEADLOCK-AVOIDED",
  "RESOURCE-TEMPORARILY-UNAVAILABLE",
  "RESULT-TOO-LARGE",
  "TOO-MANY-OPEN-FILES",
  "UNKNOWN"
};

#endif /* SCM_NTTOP_C */

#endif /* not DEFINE_WIN32_SYSCALLS */
