/* -*-C-*-

**** Do not edit this file.  It was generated by a program,
**** on Saturday January 2, 1999 at 1:36:11 AM by cph.

Copyright (c) 1999 Massachusetts Institute of Technology

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
} sm_clipboard_read_text_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  const char * text;
} sm_clipboard_read_text_reply_t;

static void handle_clipboard_read_text_request
  (sm_clipboard_read_text_request_t *);

static const char * clipboard_read_text
  (qid_t);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  const char * text;
} sm_clipboard_write_text_request_t;

static void handle_clipboard_write_text_request
  (sm_clipboard_write_text_request_t *);

static void clipboard_write_text
  (qid_t, const char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned short width;
  unsigned short height;
} sm_create_bitmap_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  bitmap_t * bitmap;
} sm_create_bitmap_reply_t;

static void handle_create_bitmap_request
  (sm_create_bitmap_request_t *);

static bitmap_t * create_bitmap
  (ps_t *, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
} sm_create_memory_ps_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_create_memory_ps_reply_t;

static void handle_create_memory_ps_request
  (sm_create_memory_ps_request_t *);

static ps_t * create_memory_ps
  (qid_t);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  bitmap_t * bitmap;
} sm_destroy_bitmap_request_t;

static void handle_destroy_bitmap_request
  (sm_destroy_bitmap_request_t *);

static void destroy_bitmap
  (bitmap_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_destroy_memory_ps_request_t;

static void handle_destroy_memory_ps_request
  (sm_destroy_memory_ps_request_t *);

static void destroy_memory_ps
  (ps_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  bitmap_t * bitmap;
  BITMAPINFOHEADER * params;
} sm_get_bitmap_parameters_request_t;

static void handle_get_bitmap_parameters_request
  (sm_get_bitmap_parameters_request_t *);

static void get_bitmap_parameters
  (bitmap_t *, BITMAPINFOHEADER *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND owner;
  unsigned short style;
  unsigned short id;
} sm_menu_create_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  HWND menu;
} sm_menu_create_reply_t;

static void handle_menu_create_request
  (sm_menu_create_request_t *);

static HWND menu_create
  (qid_t, HWND, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
} sm_menu_destroy_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_menu_destroy_reply_t;

static void handle_menu_destroy_request
  (sm_menu_destroy_request_t *);

static BOOL menu_destroy
  (qid_t, HWND);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short id;
  unsigned short submenup;
} sm_menu_get_item_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  MENUITEM * item;
} sm_menu_get_item_reply_t;

static void handle_menu_get_item_request
  (sm_menu_get_item_request_t *);

static MENUITEM * menu_get_item
  (qid_t, HWND, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short id;
  unsigned short submenup;
  unsigned short mask;
} sm_menu_get_item_attributes_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short attributes;
} sm_menu_get_item_attributes_reply_t;

static void handle_menu_get_item_attributes_request
  (sm_menu_get_item_attributes_request_t *);

static unsigned short menu_get_item_attributes
  (qid_t, HWND, unsigned short, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short position;
  unsigned short style;
  unsigned short attributes;
  unsigned short id;
  HWND submenu;
  char * text;
} sm_menu_insert_item_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short position;
} sm_menu_insert_item_reply_t;

static void handle_menu_insert_item_request
  (sm_menu_insert_item_request_t *);

static unsigned short menu_insert_item
  (qid_t, HWND, unsigned short, unsigned short, unsigned short, unsigned short, HWND, char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
} sm_menu_n_items_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short length;
} sm_menu_n_items_reply_t;

static void handle_menu_n_items_request
  (sm_menu_n_items_request_t *);

static unsigned short menu_n_items
  (qid_t, HWND);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short position;
} sm_menu_nth_item_id_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short id;
} sm_menu_nth_item_id_reply_t;

static void handle_menu_nth_item_id_request
  (sm_menu_nth_item_id_request_t *);

static unsigned short menu_nth_item_id
  (qid_t, HWND, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short id;
  unsigned short submenup;
  unsigned short deletep;
} sm_menu_remove_item_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short length;
} sm_menu_remove_item_reply_t;

static void handle_menu_remove_item_request
  (sm_menu_remove_item_request_t *);

static unsigned short menu_remove_item
  (qid_t, HWND, unsigned short, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND menu;
  unsigned short id;
  unsigned short submenup;
  unsigned short mask;
  unsigned short attributes;
} sm_menu_set_item_attributes_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_menu_set_item_attributes_reply_t;

static void handle_menu_set_item_attributes_request
  (sm_menu_set_item_attributes_request_t *);

static BOOL menu_set_item_attributes
  (qid_t, HWND, unsigned short, unsigned short, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
} sm_pm_synchronize_request_t;

static void handle_pm_synchronize_request
  (sm_pm_synchronize_request_t *);

static void pm_synchronize
  (qid_t);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * target;
  ps_t * source;
  long npoints;
  POINTL points [4];
  long rop;
  unsigned long options;
} sm_ps_bitblt_request_t;

static void handle_ps_bitblt_request
  (sm_ps_bitblt_request_t *);

static void ps_bitblt
  (ps_t *, ps_t *, long, POINTL *, long, unsigned long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short xl;
  short xh;
  short yl;
  short yh;
} sm_ps_clear_request_t;

static void handle_ps_clear_request
  (sm_ps_clear_request_t *);

static void ps_clear
  (ps_t *, short, short, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short x;
  short y;
} sm_ps_draw_line_request_t;

static void handle_ps_draw_line_request
  (sm_ps_draw_line_request_t *);

static void ps_draw_line
  (ps_t *, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short x;
  short y;
} sm_ps_draw_point_request_t;

static void handle_ps_draw_point_request
  (sm_ps_draw_point_request_t *);

static void ps_draw_point
  (ps_t *, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short x;
  short y;
  unsigned short size;
  const char data [1];
} sm_ps_draw_text_request_t;

static void handle_ps_draw_text_request
  (sm_ps_draw_text_request_t *);

static void ps_draw_text
  (ps_t *, short, short, const char *, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_ps_get_background_color_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  COLOR color;
} sm_ps_get_background_color_reply_t;

static void handle_ps_get_background_color_request
  (sm_ps_get_background_color_request_t *);

static COLOR ps_get_background_color
  (ps_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned long start;
  unsigned long length;
  BYTE * data;
  BITMAPINFO2 * info;
} sm_ps_get_bitmap_bits_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned long length;
} sm_ps_get_bitmap_bits_reply_t;

static void handle_ps_get_bitmap_bits_request
  (sm_ps_get_bitmap_bits_request_t *);

static unsigned long ps_get_bitmap_bits
  (ps_t *, unsigned long, unsigned long, BYTE *, BITMAPINFO2 *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_ps_get_font_metrics_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  font_metrics_t * metrics;
} sm_ps_get_font_metrics_reply_t;

static void handle_ps_get_font_metrics_request
  (sm_ps_get_font_metrics_request_t *);

static font_metrics_t * ps_get_font_metrics
  (ps_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_ps_get_foreground_color_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  COLOR color;
} sm_ps_get_foreground_color_reply_t;

static void handle_ps_get_foreground_color_request
  (sm_ps_get_foreground_color_request_t *);

static COLOR ps_get_foreground_color
  (ps_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short x;
  short y;
} sm_ps_move_gcursor_request_t;

static void handle_ps_move_gcursor_request
  (sm_ps_move_gcursor_request_t *);

static void ps_move_gcursor
  (ps_t *, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned long npoints;
  POINTL * points;
} sm_ps_poly_line_request_t;

static void handle_ps_poly_line_request
  (sm_ps_poly_line_request_t *);

static void ps_poly_line
  (ps_t *, unsigned long, POINTL *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned long npoints;
  POINTL * points;
} sm_ps_poly_line_disjoint_request_t;

static void handle_ps_poly_line_disjoint_request
  (sm_ps_poly_line_disjoint_request_t *);

static void ps_poly_line_disjoint
  (ps_t *, unsigned long, POINTL *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  long start;
  long count;
  long * values;
} sm_ps_query_caps_request_t;

static void handle_ps_query_caps_request
  (sm_ps_query_caps_request_t *);

static void ps_query_caps
  (ps_t *, long, long, long *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
} sm_ps_reset_clip_rectangle_request_t;

static void handle_ps_reset_clip_rectangle_request
  (sm_ps_reset_clip_rectangle_request_t *);

static void ps_reset_clip_rectangle
  (ps_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned long start;
  unsigned long length;
  BYTE * data;
  BITMAPINFO2 * info;
} sm_ps_set_bitmap_bits_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned long length;
} sm_ps_set_bitmap_bits_reply_t;

static void handle_ps_set_bitmap_bits_request
  (sm_ps_set_bitmap_bits_request_t *);

static unsigned long ps_set_bitmap_bits
  (ps_t *, unsigned long, unsigned long, BYTE *, BITMAPINFO2 *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  short xl;
  short xh;
  short yl;
  short yh;
} sm_ps_set_clip_rectangle_request_t;

static void handle_ps_set_clip_rectangle_request
  (sm_ps_set_clip_rectangle_request_t *);

static void ps_set_clip_rectangle
  (ps_t *, short, short, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  COLOR foreground;
  COLOR background;
} sm_ps_set_colors_request_t;

static void handle_ps_set_colors_request
  (sm_ps_set_colors_request_t *);

static void ps_set_colors
  (ps_t *, COLOR, COLOR);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned short id;
  const char name [1];
} sm_ps_set_font_internal_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  font_metrics_t * metrics;
} sm_ps_set_font_internal_reply_t;

static void handle_ps_set_font_internal_request
  (sm_ps_set_font_internal_request_t *);

static font_metrics_t * ps_set_font_internal
  (ps_t *, unsigned short, const char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  long type;
} sm_ps_set_line_type_request_t;

static void handle_ps_set_line_type_request
  (sm_ps_set_line_type_request_t *);

static void ps_set_line_type
  (ps_t *, long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  long mix;
} sm_ps_set_mix_request_t;

static void handle_ps_set_mix_request
  (sm_ps_set_mix_request_t *);

static void ps_set_mix
  (ps_t *, long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  ps_t * ps;
  unsigned short size;
  const char data [1];
} sm_ps_text_width_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  unsigned short width;
} sm_ps_text_width_reply_t;

static void handle_ps_text_width_request
  (sm_ps_text_width_request_t *);

static unsigned short ps_text_width
  (ps_t *, const char *, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND desktop;
  long id;
  BOOL copyp;
} sm_query_system_pointer_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  HPOINTER pointer;
} sm_query_system_pointer_reply_t;

static void handle_query_system_pointer_request
  (sm_query_system_pointer_request_t *);

static HPOINTER query_system_pointer
  (qid_t, HWND, long, BOOL);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND desktop;
  HPOINTER pointer;
} sm_set_pointer_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_set_pointer_reply_t;

static void handle_set_pointer_request
  (sm_set_pointer_request_t *);

static BOOL set_pointer
  (qid_t, HWND, HPOINTER);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
} sm_window_activate_request_t;

static void handle_window_activate_request
  (sm_window_activate_request_t *);

static void window_activate
  (window_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
} sm_window_close_request_t;

static void handle_window_close_request
  (sm_window_close_request_t *);

static void window_close
  (window_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HPOINTER icon;
} sm_window_destroy_pointer_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_window_destroy_pointer_reply_t;

static void handle_window_destroy_pointer_request
  (sm_window_destroy_pointer_request_t *);

static BOOL window_destroy_pointer
  (qid_t, HPOINTER);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
} sm_window_focusp_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  int focusp;
} sm_window_focusp_reply_t;

static void handle_window_focusp_request
  (sm_window_focusp_request_t *);

static int window_focusp
  (window_t *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  const char * title;
} sm_window_font_dialog_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  const char * spec;
} sm_window_font_dialog_reply_t;

static void handle_window_font_dialog_request
  (sm_window_font_dialog_request_t *);

static const char * window_font_dialog
  (window_t *, const char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND parent;
  unsigned long id;
} sm_window_handle_from_id_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  HWND child;
} sm_window_handle_from_id_reply_t;

static void handle_window_handle_from_id_request
  (sm_window_handle_from_id_request_t *);

static HWND window_handle_from_id
  (qid_t, HWND, unsigned long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  short xl;
  short xh;
  short yl;
  short yh;
} sm_window_invalidate_request_t;

static void handle_window_invalidate_request
  (sm_window_invalidate_request_t *);

static void window_invalidate
  (window_t *, short, short, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  HMODULE module;
  unsigned long id;
} sm_window_load_menu_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  HWND menu;
} sm_window_load_menu_reply_t;

static void handle_window_load_menu_request
  (sm_window_load_menu_request_t *);

static HWND window_load_menu
  (window_t *, HMODULE, unsigned long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND desktop;
  HMODULE module;
  unsigned long id;
} sm_window_load_pointer_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  HPOINTER pointer;
} sm_window_load_pointer_reply_t;

static void handle_window_load_pointer_request
  (sm_window_load_pointer_request_t *);

static HPOINTER window_load_pointer
  (qid_t, HWND, HMODULE, unsigned long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  short x;
  short y;
} sm_window_move_cursor_request_t;

static void handle_window_move_cursor_request
  (sm_window_move_cursor_request_t *);

static void window_move_cursor
  (window_t *, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  qid_t event_qid;
  unsigned long flags;
  HMODULE module;
  unsigned long id;
  unsigned long style;
  const char title [1];
} sm_window_open_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  wid_t wid;
} sm_window_open_reply_t;

static void handle_window_open_request
  (sm_window_open_request_t *);

static wid_t window_open
  (qid_t, qid_t, unsigned long, HMODULE, unsigned long, unsigned long, const char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND parent;
  HWND owner;
  HWND menu;
  long x;
  long y;
  long id;
  unsigned long options;
} sm_window_popup_menu_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_window_popup_menu_reply_t;

static void handle_window_popup_menu_request
  (sm_window_popup_menu_request_t *);

static BOOL window_popup_menu
  (qid_t, HWND, HWND, HWND, long, long, long, unsigned long);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  qid_t qid;
  HWND window;
  LONG id;
} sm_window_query_sys_value_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  LONG sysval;
} sm_window_query_sys_value_reply_t;

static void handle_window_query_sys_value_request
  (sm_window_query_sys_value_request_t *);

static LONG window_query_sys_value
  (qid_t, HWND, LONG);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  short xl;
  short xh;
  short yl;
  short yh;
  short x_delta;
  short y_delta;
} sm_window_scroll_request_t;

static void handle_window_scroll_request
  (sm_window_scroll_request_t *);

static void window_scroll
  (window_t *, short, short, short, short, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  int capturep;
} sm_window_set_capture_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_window_set_capture_reply_t;

static void handle_window_set_capture_request
  (sm_window_set_capture_request_t *);

static BOOL window_set_capture
  (window_t *, int);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  unsigned short x;
  unsigned short y;
} sm_window_set_grid_request_t;

static void handle_window_set_grid_request
  (sm_window_set_grid_request_t *);

static void window_set_grid
  (window_t *, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  HPOINTER icon;
} sm_window_set_icon_request_t;

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  BOOL successp;
} sm_window_set_icon_reply_t;

static void handle_window_set_icon_request
  (sm_window_set_icon_request_t *);

static BOOL window_set_icon
  (window_t *, HPOINTER);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  short x;
  short y;
} sm_window_set_pos_request_t;

static void handle_window_set_pos_request
  (sm_window_set_pos_request_t *);

static void window_set_pos
  (window_t *, short, short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  unsigned short x;
  unsigned short y;
} sm_window_set_size_request_t;

static void handle_window_set_size_request
  (sm_window_set_size_request_t *);

static void window_set_size
  (window_t *, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  window_state_t state;
} sm_window_set_state_request_t;

static void handle_window_set_state_request
  (sm_window_set_state_request_t *);

static void window_set_state
  (window_t *, window_state_t);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  const char title [1];
} sm_window_set_title_request_t;

static void handle_window_set_title_request
  (sm_window_set_title_request_t *);

static void window_set_title
  (window_t *, const char *);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  unsigned short width;
  unsigned short height;
  unsigned short style;
} sm_window_shape_cursor_request_t;

static void handle_window_shape_cursor_request
  (sm_window_shape_cursor_request_t *);

static void window_shape_cursor
  (window_t *, unsigned short, unsigned short, unsigned short);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  int showp;
} sm_window_show_request_t;

static void handle_window_show_request
  (sm_window_show_request_t *);

static void window_show
  (window_t *, int);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  int showp;
} sm_window_show_cursor_request_t;

static void handle_window_show_cursor_request
  (sm_window_show_cursor_request_t *);

static void window_show_cursor
  (window_t *, int);

typedef struct
{
  DECLARE_MSG_HEADER_FIELDS;
  window_t * window;
  unsigned short flags;
} sm_window_update_frame_request_t;

static void handle_window_update_frame_request
  (sm_window_update_frame_request_t *);

static void window_update_frame
  (window_t *, unsigned short);
