/* -*-C-*-

**** Do not edit this file.  It was generated by a program,
**** on Saturday January 2, 1999 at 1:36:11 AM by cph.

Copyright (c) 1999 Massachusetts Institute of Technology

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

const char *
OS2_clipboard_read_text (qid_t qid)
{
  sm_clipboard_read_text_request_t * request
    = (CREATE_MESSAGE (mt_clipboard_read_text_request));
  (request -> qid) = qid;
  {
    sm_clipboard_read_text_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_clipboard_read_text_reply));
    const char * text = (reply -> text);
    DESTROY_MESSAGE (reply);
    return (text);
  }
}

static void
handle_clipboard_read_text_request (sm_clipboard_read_text_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_clipboard_read_text_reply_t * reply
    = (CREATE_MESSAGE (mt_clipboard_read_text_reply));
  (reply -> text)
    = (clipboard_read_text
        (request -> qid));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_clipboard_write_text (qid_t qid, const char * text)
{
  sm_clipboard_write_text_request_t * request
    = (CREATE_MESSAGE (mt_clipboard_write_text_request));
  (request -> qid) = qid;
  (request -> text) = text;
  SYNC_TRANSACTION (qid, request);
}

static void
handle_clipboard_write_text_request (sm_clipboard_write_text_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  clipboard_write_text
    ((request -> qid), (request -> text));
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

bid_t
OS2_create_bitmap (psid_t ps_id, unsigned short width, unsigned short height)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_create_bitmap_request_t * request
    = (CREATE_MESSAGE (mt_create_bitmap_request));
  (request -> ps) = ps;
  (request -> width) = width;
  (request -> height) = height;
  {
    sm_create_bitmap_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_create_bitmap_reply));
    bitmap_t * bitmap = (reply -> bitmap);
    DESTROY_MESSAGE (reply);
    return (BITMAP_ID (bitmap));
  }
}

static void
handle_create_bitmap_request (sm_create_bitmap_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_create_bitmap_reply_t * reply
    = (CREATE_MESSAGE (mt_create_bitmap_reply));
  (reply -> bitmap)
    = (create_bitmap
        ((request -> ps), (request -> width), (request -> height)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

psid_t
OS2_create_memory_ps (qid_t qid)
{
  sm_create_memory_ps_request_t * request
    = (CREATE_MESSAGE (mt_create_memory_ps_request));
  (request -> qid) = qid;
  {
    sm_create_memory_ps_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_create_memory_ps_reply));
    ps_t * ps = (reply -> ps);
    DESTROY_MESSAGE (reply);
    return (PS_ID (ps));
  }
}

static void
handle_create_memory_ps_request (sm_create_memory_ps_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_create_memory_ps_reply_t * reply
    = (CREATE_MESSAGE (mt_create_memory_ps_reply));
  (reply -> ps)
    = (create_memory_ps
        (request -> qid));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_destroy_bitmap (bid_t bitmap_id)
{
  bitmap_t * bitmap = (bid_to_bitmap (bitmap_id));
  sm_destroy_bitmap_request_t * request
    = (CREATE_MESSAGE (mt_destroy_bitmap_request));
  (request -> bitmap) = bitmap;
  SIMPLE_TRANSACTION ((BITMAP_QID (bitmap)), request);
}

static void
handle_destroy_bitmap_request (sm_destroy_bitmap_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  destroy_bitmap
    (request -> bitmap);
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_destroy_memory_ps (psid_t ps_id)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_destroy_memory_ps_request_t * request
    = (CREATE_MESSAGE (mt_destroy_memory_ps_request));
  (request -> ps) = ps;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_destroy_memory_ps_request (sm_destroy_memory_ps_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  destroy_memory_ps
    (request -> ps);
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_get_bitmap_parameters (bid_t bitmap_id, BITMAPINFOHEADER * params)
{
  bitmap_t * bitmap = (bid_to_bitmap (bitmap_id));
  sm_get_bitmap_parameters_request_t * request
    = (CREATE_MESSAGE (mt_get_bitmap_parameters_request));
  (request -> bitmap) = bitmap;
  (request -> params) = params;
  SYNC_TRANSACTION ((BITMAP_QID (bitmap)), request);
}

static void
handle_get_bitmap_parameters_request (sm_get_bitmap_parameters_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  get_bitmap_parameters
    ((request -> bitmap), (request -> params));
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

HWND
OS2_menu_create (qid_t qid, HWND owner, unsigned short style, unsigned short id)
{
  sm_menu_create_request_t * request
    = (CREATE_MESSAGE (mt_menu_create_request));
  (request -> qid) = qid;
  (request -> owner) = owner;
  (request -> style) = style;
  (request -> id) = id;
  {
    sm_menu_create_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_create_reply));
    HWND menu = (reply -> menu);
    DESTROY_MESSAGE (reply);
    return (menu);
  }
}

static void
handle_menu_create_request (sm_menu_create_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_create_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_create_reply));
  (reply -> menu)
    = (menu_create
        ((request -> qid), (request -> owner), (request -> style), (request -> id)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

BOOL
OS2_menu_destroy (qid_t qid, HWND menu)
{
  sm_menu_destroy_request_t * request
    = (CREATE_MESSAGE (mt_menu_destroy_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  {
    sm_menu_destroy_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_destroy_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_menu_destroy_request (sm_menu_destroy_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_destroy_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_destroy_reply));
  (reply -> successp)
    = (menu_destroy
        ((request -> qid), (request -> menu)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

MENUITEM *
OS2_menu_get_item (qid_t qid, HWND menu, unsigned short id, unsigned short submenup)
{
  sm_menu_get_item_request_t * request
    = (CREATE_MESSAGE (mt_menu_get_item_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> id) = id;
  (request -> submenup) = submenup;
  {
    sm_menu_get_item_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_get_item_reply));
    MENUITEM * item = (reply -> item);
    DESTROY_MESSAGE (reply);
    return (item);
  }
}

static void
handle_menu_get_item_request (sm_menu_get_item_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_get_item_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_get_item_reply));
  (reply -> item)
    = (menu_get_item
        ((request -> qid), (request -> menu), (request -> id), (request -> submenup)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned short
OS2_menu_get_item_attributes (qid_t qid, HWND menu, unsigned short id, unsigned short submenup, unsigned short mask)
{
  sm_menu_get_item_attributes_request_t * request
    = (CREATE_MESSAGE (mt_menu_get_item_attributes_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> id) = id;
  (request -> submenup) = submenup;
  (request -> mask) = mask;
  {
    sm_menu_get_item_attributes_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_get_item_attributes_reply));
    unsigned short attributes = (reply -> attributes);
    DESTROY_MESSAGE (reply);
    return (attributes);
  }
}

static void
handle_menu_get_item_attributes_request (sm_menu_get_item_attributes_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_get_item_attributes_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_get_item_attributes_reply));
  (reply -> attributes)
    = (menu_get_item_attributes
        ((request -> qid), (request -> menu), (request -> id), (request -> submenup), (request -> mask)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned short
OS2_menu_insert_item (qid_t qid, HWND menu, unsigned short position, unsigned short style, unsigned short attributes, unsigned short id, HWND submenu, char * text)
{
  sm_menu_insert_item_request_t * request
    = (CREATE_MESSAGE (mt_menu_insert_item_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> position) = position;
  (request -> style) = style;
  (request -> attributes) = attributes;
  (request -> id) = id;
  (request -> submenu) = submenu;
  (request -> text) = text;
  {
    sm_menu_insert_item_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_insert_item_reply));
    unsigned short position = (reply -> position);
    DESTROY_MESSAGE (reply);
    return (position);
  }
}

static void
handle_menu_insert_item_request (sm_menu_insert_item_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_insert_item_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_insert_item_reply));
  (reply -> position)
    = (menu_insert_item
        ((request -> qid), (request -> menu), (request -> position), (request -> style), (request -> attributes), (request -> id), (request -> submenu), (request -> text)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned short
OS2_menu_n_items (qid_t qid, HWND menu)
{
  sm_menu_n_items_request_t * request
    = (CREATE_MESSAGE (mt_menu_n_items_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  {
    sm_menu_n_items_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_n_items_reply));
    unsigned short length = (reply -> length);
    DESTROY_MESSAGE (reply);
    return (length);
  }
}

static void
handle_menu_n_items_request (sm_menu_n_items_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_n_items_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_n_items_reply));
  (reply -> length)
    = (menu_n_items
        ((request -> qid), (request -> menu)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned short
OS2_menu_nth_item_id (qid_t qid, HWND menu, unsigned short position)
{
  sm_menu_nth_item_id_request_t * request
    = (CREATE_MESSAGE (mt_menu_nth_item_id_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> position) = position;
  {
    sm_menu_nth_item_id_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_nth_item_id_reply));
    unsigned short id = (reply -> id);
    DESTROY_MESSAGE (reply);
    return (id);
  }
}

static void
handle_menu_nth_item_id_request (sm_menu_nth_item_id_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_nth_item_id_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_nth_item_id_reply));
  (reply -> id)
    = (menu_nth_item_id
        ((request -> qid), (request -> menu), (request -> position)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned short
OS2_menu_remove_item (qid_t qid, HWND menu, unsigned short id, unsigned short submenup, unsigned short deletep)
{
  sm_menu_remove_item_request_t * request
    = (CREATE_MESSAGE (mt_menu_remove_item_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> id) = id;
  (request -> submenup) = submenup;
  (request -> deletep) = deletep;
  {
    sm_menu_remove_item_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_remove_item_reply));
    unsigned short length = (reply -> length);
    DESTROY_MESSAGE (reply);
    return (length);
  }
}

static void
handle_menu_remove_item_request (sm_menu_remove_item_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_remove_item_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_remove_item_reply));
  (reply -> length)
    = (menu_remove_item
        ((request -> qid), (request -> menu), (request -> id), (request -> submenup), (request -> deletep)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

BOOL
OS2_menu_set_item_attributes (qid_t qid, HWND menu, unsigned short id, unsigned short submenup, unsigned short mask, unsigned short attributes)
{
  sm_menu_set_item_attributes_request_t * request
    = (CREATE_MESSAGE (mt_menu_set_item_attributes_request));
  (request -> qid) = qid;
  (request -> menu) = menu;
  (request -> id) = id;
  (request -> submenup) = submenup;
  (request -> mask) = mask;
  (request -> attributes) = attributes;
  {
    sm_menu_set_item_attributes_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_menu_set_item_attributes_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_menu_set_item_attributes_request (sm_menu_set_item_attributes_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_menu_set_item_attributes_reply_t * reply
    = (CREATE_MESSAGE (mt_menu_set_item_attributes_reply));
  (reply -> successp)
    = (menu_set_item_attributes
        ((request -> qid), (request -> menu), (request -> id), (request -> submenup), (request -> mask), (request -> attributes)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_pm_synchronize (qid_t qid)
{
  sm_pm_synchronize_request_t * request
    = (CREATE_MESSAGE (mt_pm_synchronize_request));
  (request -> qid) = qid;
  SYNC_TRANSACTION (qid, request);
}

static void
handle_pm_synchronize_request (sm_pm_synchronize_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  pm_synchronize
    (request -> qid);
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

void
OS2_ps_bitblt (psid_t target_id, psid_t source_id, long npoints, POINTL * points, long rop, unsigned long options)
{
  ps_t * target = (psid_to_ps (target_id));
  ps_t * source = (psid_to_ps (source_id));
  sm_ps_bitblt_request_t * request
    = (CREATE_MESSAGE (mt_ps_bitblt_request));
  (request -> target) = target;
  (request -> source) = source;
  (request -> npoints) = npoints;
  MEMCPY ((request -> points), points, ((sizeof (POINTL)) * npoints));
  (request -> rop) = rop;
  (request -> options) = options;
  SIMPLE_TRANSACTION ((PS_QID (target)), request);
}

static void
handle_ps_bitblt_request (sm_ps_bitblt_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_bitblt
    ((request -> target), (request -> source), (request -> npoints), (request -> points), (request -> rop), (request -> options));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_clear (psid_t ps_id, short xl, short xh, short yl, short yh)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_clear_request_t * request
    = (CREATE_MESSAGE (mt_ps_clear_request));
  (request -> ps) = ps;
  (request -> xl) = xl;
  (request -> xh) = xh;
  (request -> yl) = yl;
  (request -> yh) = yh;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_clear_request (sm_ps_clear_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_clear
    ((request -> ps), (request -> xl), (request -> xh), (request -> yl), (request -> yh));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_draw_line (psid_t ps_id, short x, short y)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_draw_line_request_t * request
    = (CREATE_MESSAGE (mt_ps_draw_line_request));
  (request -> ps) = ps;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_draw_line_request (sm_ps_draw_line_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_draw_line
    ((request -> ps), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_draw_point (psid_t ps_id, short x, short y)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_draw_point_request_t * request
    = (CREATE_MESSAGE (mt_ps_draw_point_request));
  (request -> ps) = ps;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_draw_point_request (sm_ps_draw_point_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_draw_point
    ((request -> ps), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_draw_text (psid_t ps_id, short x, short y, const char * data, unsigned short size)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_draw_text_request_t * request
    = (CREATE_MESSAGE_1 (mt_ps_draw_text_request, (size - 1)));
  (request -> ps) = ps;
  (request -> x) = x;
  (request -> y) = y;
  MEMCPY ((request -> data), data, ((sizeof (const char)) * size));
  (request -> size) = size;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_draw_text_request (sm_ps_draw_text_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_draw_text
    ((request -> ps), (request -> x), (request -> y), (request -> data), (request -> size));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

COLOR
OS2_ps_get_background_color (psid_t ps_id)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_get_background_color_request_t * request
    = (CREATE_MESSAGE (mt_ps_get_background_color_request));
  (request -> ps) = ps;
  {
    sm_ps_get_background_color_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_get_background_color_reply));
    COLOR color = (reply -> color);
    DESTROY_MESSAGE (reply);
    return (color);
  }
}

static void
handle_ps_get_background_color_request (sm_ps_get_background_color_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_get_background_color_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_get_background_color_reply));
  (reply -> color)
    = (ps_get_background_color
        (request -> ps));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

unsigned long
OS2_ps_get_bitmap_bits (psid_t ps_id, unsigned long start, unsigned long length, BYTE * data, BITMAPINFO2 * info)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_get_bitmap_bits_request_t * request
    = (CREATE_MESSAGE (mt_ps_get_bitmap_bits_request));
  (request -> ps) = ps;
  (request -> start) = start;
  (request -> length) = length;
  (request -> data) = data;
  (request -> info) = info;
  {
    sm_ps_get_bitmap_bits_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_get_bitmap_bits_reply));
    unsigned long length = (reply -> length);
    DESTROY_MESSAGE (reply);
    return (length);
  }
}

static void
handle_ps_get_bitmap_bits_request (sm_ps_get_bitmap_bits_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_get_bitmap_bits_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_get_bitmap_bits_reply));
  (reply -> length)
    = (ps_get_bitmap_bits
        ((request -> ps), (request -> start), (request -> length), (request -> data), (request -> info)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

font_metrics_t *
OS2_ps_get_font_metrics (psid_t ps_id)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_get_font_metrics_request_t * request
    = (CREATE_MESSAGE (mt_ps_get_font_metrics_request));
  (request -> ps) = ps;
  {
    sm_ps_get_font_metrics_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_get_font_metrics_reply));
    font_metrics_t * metrics = (reply -> metrics);
    DESTROY_MESSAGE (reply);
    return (metrics);
  }
}

static void
handle_ps_get_font_metrics_request (sm_ps_get_font_metrics_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_get_font_metrics_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_get_font_metrics_reply));
  (reply -> metrics)
    = (ps_get_font_metrics
        (request -> ps));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

COLOR
OS2_ps_get_foreground_color (psid_t ps_id)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_get_foreground_color_request_t * request
    = (CREATE_MESSAGE (mt_ps_get_foreground_color_request));
  (request -> ps) = ps;
  {
    sm_ps_get_foreground_color_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_get_foreground_color_reply));
    COLOR color = (reply -> color);
    DESTROY_MESSAGE (reply);
    return (color);
  }
}

static void
handle_ps_get_foreground_color_request (sm_ps_get_foreground_color_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_get_foreground_color_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_get_foreground_color_reply));
  (reply -> color)
    = (ps_get_foreground_color
        (request -> ps));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_ps_move_gcursor (psid_t ps_id, short x, short y)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_move_gcursor_request_t * request
    = (CREATE_MESSAGE (mt_ps_move_gcursor_request));
  (request -> ps) = ps;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_move_gcursor_request (sm_ps_move_gcursor_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_move_gcursor
    ((request -> ps), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_poly_line (psid_t ps_id, unsigned long npoints, POINTL * points)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_poly_line_request_t * request
    = (CREATE_MESSAGE (mt_ps_poly_line_request));
  (request -> ps) = ps;
  (request -> npoints) = npoints;
  (request -> points) = points;
  SYNC_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_poly_line_request (sm_ps_poly_line_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_poly_line
    ((request -> ps), (request -> npoints), (request -> points));
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

void
OS2_ps_poly_line_disjoint (psid_t ps_id, unsigned long npoints, POINTL * points)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_poly_line_disjoint_request_t * request
    = (CREATE_MESSAGE (mt_ps_poly_line_disjoint_request));
  (request -> ps) = ps;
  (request -> npoints) = npoints;
  (request -> points) = points;
  SYNC_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_poly_line_disjoint_request (sm_ps_poly_line_disjoint_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_poly_line_disjoint
    ((request -> ps), (request -> npoints), (request -> points));
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

void
OS2_ps_query_caps (psid_t ps_id, long start, long count, long * values)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_query_caps_request_t * request
    = (CREATE_MESSAGE (mt_ps_query_caps_request));
  (request -> ps) = ps;
  (request -> start) = start;
  (request -> count) = count;
  (request -> values) = values;
  SYNC_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_query_caps_request (sm_ps_query_caps_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_query_caps
    ((request -> ps), (request -> start), (request -> count), (request -> values));
  DESTROY_MESSAGE (request);
  sync_reply (sender);
}

void
OS2_ps_reset_clip_rectangle (psid_t ps_id)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_reset_clip_rectangle_request_t * request
    = (CREATE_MESSAGE (mt_ps_reset_clip_rectangle_request));
  (request -> ps) = ps;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_reset_clip_rectangle_request (sm_ps_reset_clip_rectangle_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_reset_clip_rectangle
    (request -> ps);
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

unsigned long
OS2_ps_set_bitmap_bits (psid_t ps_id, unsigned long start, unsigned long length, BYTE * data, BITMAPINFO2 * info)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_bitmap_bits_request_t * request
    = (CREATE_MESSAGE (mt_ps_set_bitmap_bits_request));
  (request -> ps) = ps;
  (request -> start) = start;
  (request -> length) = length;
  (request -> data) = data;
  (request -> info) = info;
  {
    sm_ps_set_bitmap_bits_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_set_bitmap_bits_reply));
    unsigned long length = (reply -> length);
    DESTROY_MESSAGE (reply);
    return (length);
  }
}

static void
handle_ps_set_bitmap_bits_request (sm_ps_set_bitmap_bits_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_set_bitmap_bits_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_set_bitmap_bits_reply));
  (reply -> length)
    = (ps_set_bitmap_bits
        ((request -> ps), (request -> start), (request -> length), (request -> data), (request -> info)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_ps_set_clip_rectangle (psid_t ps_id, short xl, short xh, short yl, short yh)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_clip_rectangle_request_t * request
    = (CREATE_MESSAGE (mt_ps_set_clip_rectangle_request));
  (request -> ps) = ps;
  (request -> xl) = xl;
  (request -> xh) = xh;
  (request -> yl) = yl;
  (request -> yh) = yh;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_set_clip_rectangle_request (sm_ps_set_clip_rectangle_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_set_clip_rectangle
    ((request -> ps), (request -> xl), (request -> xh), (request -> yl), (request -> yh));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_set_colors (psid_t ps_id, COLOR foreground, COLOR background)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_colors_request_t * request
    = (CREATE_MESSAGE (mt_ps_set_colors_request));
  (request -> ps) = ps;
  (request -> foreground) = foreground;
  (request -> background) = background;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_set_colors_request (sm_ps_set_colors_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_set_colors
    ((request -> ps), (request -> foreground), (request -> background));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

font_metrics_t *
OS2_ps_set_font_internal (psid_t ps_id, unsigned short id, const char * name)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_font_internal_request_t * request
    = (CREATE_MESSAGE_1 (mt_ps_set_font_internal_request, (strlen (name))));
  (request -> ps) = ps;
  (request -> id) = id;
  STRCPY ((request -> name), name);
  {
    sm_ps_set_font_internal_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_set_font_internal_reply));
    font_metrics_t * metrics = (reply -> metrics);
    DESTROY_MESSAGE (reply);
    return (metrics);
  }
}

static void
handle_ps_set_font_internal_request (sm_ps_set_font_internal_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_set_font_internal_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_set_font_internal_reply));
  (reply -> metrics)
    = (ps_set_font_internal
        ((request -> ps), (request -> id), (request -> name)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_ps_set_line_type (psid_t ps_id, long type)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_line_type_request_t * request
    = (CREATE_MESSAGE (mt_ps_set_line_type_request));
  (request -> ps) = ps;
  (request -> type) = type;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_set_line_type_request (sm_ps_set_line_type_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_set_line_type
    ((request -> ps), (request -> type));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_ps_set_mix (psid_t ps_id, long mix)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_set_mix_request_t * request
    = (CREATE_MESSAGE (mt_ps_set_mix_request));
  (request -> ps) = ps;
  (request -> mix) = mix;
  SIMPLE_TRANSACTION ((PS_QID (ps)), request);
}

static void
handle_ps_set_mix_request (sm_ps_set_mix_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  ps_set_mix
    ((request -> ps), (request -> mix));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

unsigned short
OS2_ps_text_width (psid_t ps_id, const char * data, unsigned short size)
{
  ps_t * ps = (psid_to_ps (ps_id));
  sm_ps_text_width_request_t * request
    = (CREATE_MESSAGE_1 (mt_ps_text_width_request, (size - 1)));
  (request -> ps) = ps;
  MEMCPY ((request -> data), data, ((sizeof (const char)) * size));
  (request -> size) = size;
  {
    sm_ps_text_width_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((PS_QID (ps)), request, mt_ps_text_width_reply));
    unsigned short width = (reply -> width);
    DESTROY_MESSAGE (reply);
    return (width);
  }
}

static void
handle_ps_text_width_request (sm_ps_text_width_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_ps_text_width_reply_t * reply
    = (CREATE_MESSAGE (mt_ps_text_width_reply));
  (reply -> width)
    = (ps_text_width
        ((request -> ps), (request -> data), (request -> size)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

HPOINTER
OS2_query_system_pointer (qid_t qid, HWND desktop, long id, BOOL copyp)
{
  sm_query_system_pointer_request_t * request
    = (CREATE_MESSAGE (mt_query_system_pointer_request));
  (request -> qid) = qid;
  (request -> desktop) = desktop;
  (request -> id) = id;
  (request -> copyp) = copyp;
  {
    sm_query_system_pointer_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_query_system_pointer_reply));
    HPOINTER pointer = (reply -> pointer);
    DESTROY_MESSAGE (reply);
    return (pointer);
  }
}

static void
handle_query_system_pointer_request (sm_query_system_pointer_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_query_system_pointer_reply_t * reply
    = (CREATE_MESSAGE (mt_query_system_pointer_reply));
  (reply -> pointer)
    = (query_system_pointer
        ((request -> qid), (request -> desktop), (request -> id), (request -> copyp)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

BOOL
OS2_set_pointer (qid_t qid, HWND desktop, HPOINTER pointer)
{
  sm_set_pointer_request_t * request
    = (CREATE_MESSAGE (mt_set_pointer_request));
  (request -> qid) = qid;
  (request -> desktop) = desktop;
  (request -> pointer) = pointer;
  {
    sm_set_pointer_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_set_pointer_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_set_pointer_request (sm_set_pointer_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_set_pointer_reply_t * reply
    = (CREATE_MESSAGE (mt_set_pointer_reply));
  (reply -> successp)
    = (set_pointer
        ((request -> qid), (request -> desktop), (request -> pointer)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_activate (wid_t window_id)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_activate_request_t * request
    = (CREATE_MESSAGE (mt_window_activate_request));
  (request -> window) = window;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_activate_request (sm_window_activate_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_activate
    (request -> window);
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_close (wid_t window_id)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_close_request_t * request
    = (CREATE_MESSAGE (mt_window_close_request));
  (request -> window) = window;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_close_request (sm_window_close_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_close
    (request -> window);
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

BOOL
OS2_window_destroy_pointer (qid_t qid, HPOINTER icon)
{
  sm_window_destroy_pointer_request_t * request
    = (CREATE_MESSAGE (mt_window_destroy_pointer_request));
  (request -> qid) = qid;
  (request -> icon) = icon;
  {
    sm_window_destroy_pointer_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_destroy_pointer_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_window_destroy_pointer_request (sm_window_destroy_pointer_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_destroy_pointer_reply_t * reply
    = (CREATE_MESSAGE (mt_window_destroy_pointer_reply));
  (reply -> successp)
    = (window_destroy_pointer
        ((request -> qid), (request -> icon)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

int
OS2_window_focusp (wid_t window_id)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_focusp_request_t * request
    = (CREATE_MESSAGE (mt_window_focusp_request));
  (request -> window) = window;
  {
    sm_window_focusp_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((WINDOW_QID (window)), request, mt_window_focusp_reply));
    int focusp = (reply -> focusp);
    DESTROY_MESSAGE (reply);
    return (focusp);
  }
}

static void
handle_window_focusp_request (sm_window_focusp_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_focusp_reply_t * reply
    = (CREATE_MESSAGE (mt_window_focusp_reply));
  (reply -> focusp)
    = (window_focusp
        (request -> window));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

const char *
OS2_window_font_dialog (wid_t window_id, const char * title)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_font_dialog_request_t * request
    = (CREATE_MESSAGE (mt_window_font_dialog_request));
  (request -> window) = window;
  (request -> title) = title;
  {
    sm_window_font_dialog_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((WINDOW_QID (window)), request, mt_window_font_dialog_reply));
    const char * spec = (reply -> spec);
    DESTROY_MESSAGE (reply);
    return (spec);
  }
}

static void
handle_window_font_dialog_request (sm_window_font_dialog_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_font_dialog_reply_t * reply
    = (CREATE_MESSAGE (mt_window_font_dialog_reply));
  (reply -> spec)
    = (window_font_dialog
        ((request -> window), (request -> title)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

HWND
OS2_window_handle_from_id (qid_t qid, HWND parent, unsigned long id)
{
  sm_window_handle_from_id_request_t * request
    = (CREATE_MESSAGE (mt_window_handle_from_id_request));
  (request -> qid) = qid;
  (request -> parent) = parent;
  (request -> id) = id;
  {
    sm_window_handle_from_id_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_handle_from_id_reply));
    HWND child = (reply -> child);
    DESTROY_MESSAGE (reply);
    return (child);
  }
}

static void
handle_window_handle_from_id_request (sm_window_handle_from_id_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_handle_from_id_reply_t * reply
    = (CREATE_MESSAGE (mt_window_handle_from_id_reply));
  (reply -> child)
    = (window_handle_from_id
        ((request -> qid), (request -> parent), (request -> id)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_invalidate (wid_t window_id, short xl, short xh, short yl, short yh)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_invalidate_request_t * request
    = (CREATE_MESSAGE (mt_window_invalidate_request));
  (request -> window) = window;
  (request -> xl) = xl;
  (request -> xh) = xh;
  (request -> yl) = yl;
  (request -> yh) = yh;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_invalidate_request (sm_window_invalidate_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_invalidate
    ((request -> window), (request -> xl), (request -> xh), (request -> yl), (request -> yh));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

HWND
OS2_window_load_menu (wid_t window_id, HMODULE module, unsigned long id)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_load_menu_request_t * request
    = (CREATE_MESSAGE (mt_window_load_menu_request));
  (request -> window) = window;
  (request -> module) = module;
  (request -> id) = id;
  {
    sm_window_load_menu_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((WINDOW_QID (window)), request, mt_window_load_menu_reply));
    HWND menu = (reply -> menu);
    DESTROY_MESSAGE (reply);
    return (menu);
  }
}

static void
handle_window_load_menu_request (sm_window_load_menu_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_load_menu_reply_t * reply
    = (CREATE_MESSAGE (mt_window_load_menu_reply));
  (reply -> menu)
    = (window_load_menu
        ((request -> window), (request -> module), (request -> id)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

HPOINTER
OS2_window_load_pointer (qid_t qid, HWND desktop, HMODULE module, unsigned long id)
{
  sm_window_load_pointer_request_t * request
    = (CREATE_MESSAGE (mt_window_load_pointer_request));
  (request -> qid) = qid;
  (request -> desktop) = desktop;
  (request -> module) = module;
  (request -> id) = id;
  {
    sm_window_load_pointer_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_load_pointer_reply));
    HPOINTER pointer = (reply -> pointer);
    DESTROY_MESSAGE (reply);
    return (pointer);
  }
}

static void
handle_window_load_pointer_request (sm_window_load_pointer_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_load_pointer_reply_t * reply
    = (CREATE_MESSAGE (mt_window_load_pointer_reply));
  (reply -> pointer)
    = (window_load_pointer
        ((request -> qid), (request -> desktop), (request -> module), (request -> id)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_move_cursor (wid_t window_id, short x, short y)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_move_cursor_request_t * request
    = (CREATE_MESSAGE (mt_window_move_cursor_request));
  (request -> window) = window;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_move_cursor_request (sm_window_move_cursor_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_move_cursor
    ((request -> window), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

wid_t
OS2_window_open (qid_t qid, qid_t event_qid, unsigned long flags, HMODULE module, unsigned long id, unsigned long style, const char * title)
{
  sm_window_open_request_t * request
    = (CREATE_MESSAGE_1 (mt_window_open_request, (strlen (title))));
  (request -> qid) = qid;
  (request -> event_qid) = event_qid;
  (request -> flags) = flags;
  (request -> module) = module;
  (request -> id) = id;
  (request -> style) = style;
  STRCPY ((request -> title), title);
  {
    sm_window_open_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_open_reply));
    wid_t wid = (reply -> wid);
    DESTROY_MESSAGE (reply);
    return (wid);
  }
}

static void
handle_window_open_request (sm_window_open_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_open_reply_t * reply
    = (CREATE_MESSAGE (mt_window_open_reply));
  (reply -> wid)
    = (window_open
        ((request -> qid), (request -> event_qid), (request -> flags), (request -> module), (request -> id), (request -> style), (request -> title)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

BOOL
OS2_window_popup_menu (qid_t qid, HWND parent, HWND owner, HWND menu, long x, long y, long id, unsigned long options)
{
  sm_window_popup_menu_request_t * request
    = (CREATE_MESSAGE (mt_window_popup_menu_request));
  (request -> qid) = qid;
  (request -> parent) = parent;
  (request -> owner) = owner;
  (request -> menu) = menu;
  (request -> x) = x;
  (request -> y) = y;
  (request -> id) = id;
  (request -> options) = options;
  {
    sm_window_popup_menu_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_popup_menu_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_window_popup_menu_request (sm_window_popup_menu_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_popup_menu_reply_t * reply
    = (CREATE_MESSAGE (mt_window_popup_menu_reply));
  (reply -> successp)
    = (window_popup_menu
        ((request -> qid), (request -> parent), (request -> owner), (request -> menu), (request -> x), (request -> y), (request -> id), (request -> options)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

LONG
OS2_window_query_sys_value (qid_t qid, HWND window, LONG id)
{
  sm_window_query_sys_value_request_t * request
    = (CREATE_MESSAGE (mt_window_query_sys_value_request));
  (request -> qid) = qid;
  (request -> window) = window;
  (request -> id) = id;
  {
    sm_window_query_sys_value_reply_t * reply
      = (MESSAGE_TRANSACTION
          (qid, request, mt_window_query_sys_value_reply));
    LONG sysval = (reply -> sysval);
    DESTROY_MESSAGE (reply);
    return (sysval);
  }
}

static void
handle_window_query_sys_value_request (sm_window_query_sys_value_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_query_sys_value_reply_t * reply
    = (CREATE_MESSAGE (mt_window_query_sys_value_reply));
  (reply -> sysval)
    = (window_query_sys_value
        ((request -> qid), (request -> window), (request -> id)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_scroll (wid_t window_id, short xl, short xh, short yl, short yh, short x_delta, short y_delta)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_scroll_request_t * request
    = (CREATE_MESSAGE (mt_window_scroll_request));
  (request -> window) = window;
  (request -> xl) = xl;
  (request -> xh) = xh;
  (request -> yl) = yl;
  (request -> yh) = yh;
  (request -> x_delta) = x_delta;
  (request -> y_delta) = y_delta;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_scroll_request (sm_window_scroll_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_scroll
    ((request -> window), (request -> xl), (request -> xh), (request -> yl), (request -> yh), (request -> x_delta), (request -> y_delta));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

BOOL
OS2_window_set_capture (wid_t window_id, int capturep)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_capture_request_t * request
    = (CREATE_MESSAGE (mt_window_set_capture_request));
  (request -> window) = window;
  (request -> capturep) = capturep;
  {
    sm_window_set_capture_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((WINDOW_QID (window)), request, mt_window_set_capture_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_window_set_capture_request (sm_window_set_capture_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_set_capture_reply_t * reply
    = (CREATE_MESSAGE (mt_window_set_capture_reply));
  (reply -> successp)
    = (window_set_capture
        ((request -> window), (request -> capturep)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_set_grid (wid_t window_id, unsigned short x, unsigned short y)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_grid_request_t * request
    = (CREATE_MESSAGE (mt_window_set_grid_request));
  (request -> window) = window;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_set_grid_request (sm_window_set_grid_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_set_grid
    ((request -> window), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

BOOL
OS2_window_set_icon (wid_t window_id, HPOINTER icon)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_icon_request_t * request
    = (CREATE_MESSAGE (mt_window_set_icon_request));
  (request -> window) = window;
  (request -> icon) = icon;
  {
    sm_window_set_icon_reply_t * reply
      = (MESSAGE_TRANSACTION
          ((WINDOW_QID (window)), request, mt_window_set_icon_reply));
    BOOL successp = (reply -> successp);
    DESTROY_MESSAGE (reply);
    return (successp);
  }
}

static void
handle_window_set_icon_request (sm_window_set_icon_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  sm_window_set_icon_reply_t * reply
    = (CREATE_MESSAGE (mt_window_set_icon_reply));
  (reply -> successp)
    = (window_set_icon
        ((request -> window), (request -> icon)));
  DESTROY_MESSAGE (request);
  SEND_MESSAGE (sender, reply);
}

void
OS2_window_set_pos (wid_t window_id, short x, short y)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_pos_request_t * request
    = (CREATE_MESSAGE (mt_window_set_pos_request));
  (request -> window) = window;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_set_pos_request (sm_window_set_pos_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_set_pos
    ((request -> window), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_set_size (wid_t window_id, unsigned short x, unsigned short y)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_size_request_t * request
    = (CREATE_MESSAGE (mt_window_set_size_request));
  (request -> window) = window;
  (request -> x) = x;
  (request -> y) = y;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_set_size_request (sm_window_set_size_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_set_size
    ((request -> window), (request -> x), (request -> y));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_set_state (wid_t window_id, window_state_t state)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_state_request_t * request
    = (CREATE_MESSAGE (mt_window_set_state_request));
  (request -> window) = window;
  (request -> state) = state;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_set_state_request (sm_window_set_state_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_set_state
    ((request -> window), (request -> state));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_set_title (wid_t window_id, const char * title)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_set_title_request_t * request
    = (CREATE_MESSAGE_1 (mt_window_set_title_request, (strlen (title))));
  (request -> window) = window;
  STRCPY ((request -> title), title);
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_set_title_request (sm_window_set_title_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_set_title
    ((request -> window), (request -> title));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_shape_cursor (wid_t window_id, unsigned short width, unsigned short height, unsigned short style)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_shape_cursor_request_t * request
    = (CREATE_MESSAGE (mt_window_shape_cursor_request));
  (request -> window) = window;
  (request -> width) = width;
  (request -> height) = height;
  (request -> style) = style;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_shape_cursor_request (sm_window_shape_cursor_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_shape_cursor
    ((request -> window), (request -> width), (request -> height), (request -> style));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_show (wid_t window_id, int showp)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_show_request_t * request
    = (CREATE_MESSAGE (mt_window_show_request));
  (request -> window) = window;
  (request -> showp) = showp;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_show_request (sm_window_show_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_show
    ((request -> window), (request -> showp));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_show_cursor (wid_t window_id, int showp)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_show_cursor_request_t * request
    = (CREATE_MESSAGE (mt_window_show_cursor_request));
  (request -> window) = window;
  (request -> showp) = showp;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_show_cursor_request (sm_window_show_cursor_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_show_cursor
    ((request -> window), (request -> showp));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}

void
OS2_window_update_frame (wid_t window_id, unsigned short flags)
{
  window_t * window = (wid_to_window (window_id));
  sm_window_update_frame_request_t * request
    = (CREATE_MESSAGE (mt_window_update_frame_request));
  (request -> window) = window;
  (request -> flags) = flags;
  SIMPLE_TRANSACTION ((WINDOW_QID (window)), request);
}

static void
handle_window_update_frame_request (sm_window_update_frame_request_t * request)
{
  qid_t sender = (MSG_SENDER (request));
  window_update_frame
    ((request -> window), (request -> flags));
  DESTROY_MESSAGE (request);
  simple_reply (sender);
}
