/* -*-C-*-
   System file for Linux

$Id: linux.h,v 1.20 2000/02/07 04:53:08 cph Exp $

Copyright (c) 1995-2000 Massachusetts Institute of Technology

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define LIBX11_SYSTEM -L/usr/X11R6/lib

#define LIB_DEBUG

#define ALTERNATE_M4 s/ultrix.m4

#define LINUX_STATIC_LIBS(libs) -Xlinker -Bstatic libs -Xlinker -Bdynamic

#ifdef __ELF__
#if ((__GNUC__ > 2) || ((__GNUC__ == 2) && (__GNUC_MINOR__ >= 95)))
#define M4_SWITCH_SYSTEM -P "define(LINUX_ELF,1)" -P "define(CALLEE_POPS_STRUCT_RETURN,1)"
#else
#define M4_SWITCH_SYSTEM -P "define(LINUX_ELF,1)"
#endif
/* Newer versions of Debian don't really support termcap.  However,
   ncurses is supported on all GNU/Linux systems, so we'll use that
   instead.  */
#define LIBS_TERMCAP LINUX_STATIC_LIBS (-lncurses)
#define HAVE_TERMINFO
/* Comment out the following line if you are running ncurses 1.9.9g or
   later.  Version 1.9.9e and earlier defined "tparam", but version
   1.9.9g and later do not.  */
/* #define TERMCAP_FILES */
#else
#define M4_SWITCH_SYSTEM
#define LIBS_TERMCAP LINUX_STATIC_LIBS (-ltermcap)
#endif

#define LD_SWITCH_SYSTEM -export-dynamic

#ifndef DISABLE_DLD_SUPPORT
/* These definitions configure the microcode to support dynamic loading. */
#define SOURCES_SYSTEM pruxdld.c
#define OBJECTS_SYSTEM pruxdld.o
#define LIBS_SYSTEM -ldl
#endif

/* Use the built-in files <limits.h> and <float.h> rather than those
   generated by the "hard-par" program.  */
#define USE_BUILT_IN_LIMITS_FILES
